﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
#Event: BitmapReady (bmp As B4XBitmap)
Sub Class_Globals
	Private mBuffer() As Byte
	Public mWidth, mHeight As Int
	Private ai, ri, gi, bi As Int
	Type PremultipliedColor (a As Int, r As Int, g As Int, b As Int)
	Type ARGBColor (a As Int, r As Int, g As Int, b As Int)
	Type DrawTask (Source As Object, SrcRect As B4XRect, TargetX As Int, TargetY As Int, _
		SkipBlending As Boolean, SrcScaleX As Float, SrcScaleY As Float, Degrees As Int, _
		Transform As Boolean, IsCompressedSource As Boolean, TargetBC As BitmapCreator, _
		IsCanvasTask As Boolean, CanvasTask As InternalCanvasDrawTask)
	Type CompressedBC (Rows As List, mBuffer() As Byte, mWidth As Int, mHeight As Int, TargetRect As B4XRect, Cache As InternalCompressedBCCache)
	Type InternalCompressedBCCache (ColorsMap As Map, mBuffer() As Byte)
	#if B4J or B4A
	Type InternalAntiAliasingBuffer (IntsArray() As Int)
	Type InternalBCColumn (Values() As Float, StartY As Int, EndY As Int, LeftSide As Boolean)
	#else
	Type InternalAntiAliasingBuffer (IntsArray() As Byte)
	Type InternalBCColumn (Values() As Byte, StartY As Int, EndY As Int, LeftSide As Boolean)
	#end if
	Private tempARGB As ARGBColor
	Private tempPM, tempPM2 As PremultipliedColor
#if B4A
	Private b4abmp As Bitmap
	
	Private jme As JavaObject
#else if B4J
	Private WriteableImage As JavaObject
	Private jme As JavaObject
#Else
	Private jme As NativeObject
	Private ShouldClearBeforeExtracting As Boolean
#end if
	Public TargetRect As B4XRect
	Private UnsignedFF As Int
	Private xui As XUI
	Private const CACHE_TRANSPARENT = 0, CACHE_SOLID = 1 As Byte
#if B4i
	Public SAME_COLOR_LENGTH_FOR_CACHE As Int = 40
#else
	Public SAME_COLOR_LENGTH_FOR_CACHE As Int = 20
#end if
	Public MAX_SAME_COLOR_SIZE As Int = 5000
	#if Stats
	Public ClockForAsync As Long
	#End If
	Private ReadyColumns As List
	Public AlphaThresholdForCBCExtraction as int = 30
End Sub

'Initializes the object and sets the bitmap dimensions.
'Note that XUI library must be referenced as well.
Public Sub Initialize (Width As Int, Height As Int)
	Dim b As Byte = 0xff
	UnsignedFF = b
	mWidth = Width
	mHeight = Height
	Dim mBuffer(mWidth * mHeight * 4) As Byte
	#if B4A or B4i
	ai = 3
	ri = 0
	gi = 1
	bi = 2
	#else if B4J
	ai = 3
	ri = 2
	gi = 1
	bi = 0
	
	#end if
	jme = Me
	TargetRect.Initialize(0, 0, mWidth, mHeight)
End Sub

'Gets the internal buffer.
Public Sub getBuffer() As Byte()
	Return mBuffer
End Sub

'Extracts the pixels from the SourceBitmap and copies them.
'Note that the source bitmap is first resized, if needed, to match the BitmapCreator dimensions.
Public Sub CopyPixelsFromBitmap (SourceBitmap As B4XBitmap)
	If SourceBitmap.Width <> mWidth Or SourceBitmap.Height <> mHeight Then
'		Log("resize: " & SourceBitmap.Scale)
		SourceBitmap = SourceBitmap.Resize(mWidth, mHeight, False)
	End If
	#if B4A
	Dim jo As JavaObject = SourceBitmap
	Dim format As Object = jo.RunMethod("getConfig", Null)
	If "ARGB_8888" <> format Then
		Log("Unsupported format: " & format)
		Return
	End If
	Dim bf As JavaObject
	bf = bf.InitializeStatic("java.nio.ByteBuffer").RunMethodJO("wrap", Array(mBuffer))
	jo.RunMethod("copyPixelsToBuffer", Array(bf))
	#else if B4J
	Dim jo As JavaObject = SourceBitmap
	Dim reader As JavaObject = jo.RunMethod("getPixelReader", Null)
	Dim PixelFormat As JavaObject
	PixelFormat.InitializeStatic("javafx.scene.image.PixelFormat")
	reader.RunMethod("getPixels", Array(0, 0, mWidth, mHeight, PixelFormat.RunMethod("getByteBgraPreInstance", Null), _
       mBuffer, 0, mWidth * 4))
	 #Else If B4i
	Dim no As NativeObject = Me
	no.RunMethod("UIImageToBuffer:::::", Array(SourceBitmap, no.ArrayToNSData(mBuffer), mWidth, mHeight, ShouldClearBeforeExtracting))
	ShouldClearBeforeExtracting = True
	#End If
End Sub

'Sets the color of the given pixel.
Public Sub SetColor(x As Int, y As Int, Clr As Int)
	ColorToARGB(Clr, tempARGB)
	SetARGB(x, y, tempARGB)
End Sub

'Converts color int to ARGBColor object.
'The Result parameter will hold the output.
Public Sub ColorToARGB (Clr As Int, Result As ARGBColor) As ARGBColor
	Result.a = Bit.And(0xff, Bit.ShiftRight(Clr, 24))
	Result.r = Bit.And(0xff, Bit.ShiftRight(Clr, 16))
	Result.g =  Bit.And(0xff, Bit.ShiftRight(Clr, 8))
	Result.b =  Bit.And(0xff, Clr)
	Return Result
End Sub

'Converts an ARGB value to a color int value.
Public Sub ARGBToColor (ARGB As ARGBColor) As Int
	Return Bit.ShiftLeft(ARGB.a, 24) + Bit.ShiftLeft(ARGB.r, 16) + Bit.ShiftLeft(ARGB.g, 8) + ARGB.b
End Sub

'Similar to B4XView.SetBitmap. The difference is in B4A where the Gravity is set to FILL instead of CENTER.
'This is useful when you want to use a scaled down bitmap.
'In most cases you should use this method instead of B4XView.SetBitmap.
Public Sub SetBitmapToImageView (Bitmap As B4XBitmap, ImageView As B4XView)
	ImageView.SetBitmap(Bitmap)
	#if B4A
	'B4XView.SetBitmap sets the gravity in B4A to CENTER. This will prevent the bitmap from being scaled as needed so
	'we switch to FILL
	Dim iv As ImageView = ImageView
	iv.Gravity = Gravity.FILL
	#End If
End Sub

'Converts an ARGB color to PremultipliedColor.
'The Result parameter will hold the output.
Public Sub ARGBToPremultipliedColor (ARGB As ARGBColor, PM As PremultipliedColor) As PremultipliedColor
	Dim a As Float = ARGB.a / 255
	PM.a = ARGB.a
	PM.r = ARGB.r * a
	PM.g = ARGB.g * a
	PM.b = ARGB.b * a
	Return PM
End Sub

'Sets the color of the specified point.
Public Sub SetHSV(x As Int, y As Int, alpha As Int, h As Int, s As Float, v As Float)
	Dim r, g, b As Float
	Dim hi As Int = Floor(h / 60)
	Dim hbucket As Int =  hi Mod 6
	Dim f As Float = h / 60 - hi
	Dim p As Float = v * (1 - s)
	Dim q As Float = v  * (1 - f * s)
	Dim t As Float = v * (1 - (1 - f) * s)
	Select hbucket
		Case 0
			r = v
			g = t
			b = p
		Case 1
			r = q
			g = v
			b = p
		Case 2
			r = p
			g = v
			b = t
		Case 3
			r = p
			g = q
			b = v
		Case 4
			r = t
			g = p
			b = v
		Case 5
			r = v
			g = p
			b = q
	End Select
	tempARGB.a = alpha
	tempARGB.r = r * 255
	tempARGB.g = g * 255
	tempARGB.b = b * 255
	SetARGB(x, y, tempARGB)
End Sub

'Sets the color of the specified point.
Public Sub SetARGB(x As Int, y As Int, ARGB As ARGBColor)
	SetPremultipliedColor(x, y, ARGBToPremultipliedColor(ARGB, tempPM))
End Sub

'Sets the color of the specified point. 
Public Sub SetPremultipliedColor (x As Int, y As Int, Premultiplied As PremultipliedColor)
	Dim cp As Int = x * 4 + y * mWidth * 4
	#if B4i
	Bit.FastArraySetByte(mBuffer, cp + ri, Premultiplied.r)
	Bit.FastArraySetByte(mBuffer, cp + gi, Premultiplied.g)
	Bit.FastArraySetByte(mBuffer, cp + bi, Premultiplied.b)
	Bit.FastArraySetByte(mBuffer, cp + ai, Premultiplied.a)
	#else
	mBuffer(cp + ri) = Premultiplied.r
	mBuffer(cp + gi) = Premultiplied.g
	mBuffer(cp + bi) = Premultiplied.b
	mBuffer(cp + ai) = Premultiplied.a
	#End If
	
End Sub

'Gets the color of the given point as a premultiplied color. No conversion is required for this format.
'The Result parameter stores the output.
Public Sub GetPremultipliedColor (x As Int, y As Int, Result As PremultipliedColor) As PremultipliedColor
	Dim cp As Int = x * 4 + y * mWidth * 4
	#if B4i
	Result.r = Bit.FastArrayGetByte(mBuffer, cp + ri)
	Result.g = Bit.FastArrayGetByte(mBuffer, cp + gi)
	Result.b = Bit.FastArrayGetByte(mBuffer, cp + bi)
	Result.a = Bit.FastArrayGetByte(mBuffer, cp + ai)
	#else
	Result.r = mBuffer(cp + ri)
	Result.g = mBuffer(cp + gi)
	Result.b = mBuffer(cp + bi)
	Result.a = mBuffer(cp + ai)
	#End If
	Return Result
End Sub

'Gets the color of the given point as an int value.
Public Sub GetColor (x As Int, y As Int) As Int
	GetARGB(x, y, tempARGB)
	Return Bit.ShiftLeft(tempARGB.a, 24) + Bit.ShiftLeft(tempARGB.r, 16) + Bit.ShiftLeft(tempARGB.g, 8) + tempARGB.b
End Sub

'Gets the color of the given point as an ARGB color.
'The Result parameter stores the output.
Public Sub GetARGB (x As Int, y As Int, Result As ARGBColor) As ARGBColor
	Dim cp As Int = x * 4 + y * mWidth * 4
#if B4i
	Result.a = Bit.FastArrayGetByte(mBuffer, cp + ai)
	Dim af As Float = Result.a / 255
	Result.r = Bit.FastArrayGetByte(mBuffer, cp + ri) / af
	Result.g = Bit.FastArrayGetByte(mBuffer, cp + gi) / af
	Result.b = Bit.FastArrayGetByte(mBuffer, cp + bi) / af
#Else
	Result.a = Bit.And(0xff, mBuffer(cp + ai))
	Dim af As Float = Result.a / 255
	Result.r = Bit.And(0xff, mBuffer(cp + ri)) / af
	Result.g = Bit.And(0xff, mBuffer(cp + gi)) / af
	Result.b = Bit.And(0xff, mBuffer(cp + bi)) / af
#End If
	
	Return Result
End Sub

'Tests whether a given point is completely transparent.
Public Sub IsTransparent(x As Int, y As Int) As Boolean
	Dim cp As Int = x * 4 + y * mWidth * 4
	Return mBuffer(cp + ai) = 0
End Sub

'Converts the bytes buffer to a bitmap.
Public Sub getBitmap As B4XBitmap
	#if Stats
	Dim Clock As Long = DateTime.Now
	#End If
	#if B4A
	Dim bf As JavaObject
	bf = bf.InitializeStatic("java.nio.ByteBuffer").RunMethodJO("wrap", Array(mBuffer))
	If b4abmp.IsInitialized = False Then
		b4abmp.InitializeMutable(mWidth, mHeight)
	End If
	Dim jo As JavaObject = b4abmp
	jo.RunMethod("setDensity", Array(160))
	jo.RunMethod("copyPixelsFromBuffer", Array(bf))
	jo.RunMethod("prepareToDraw", Null)
	#if Stats
	Log($"Get Bitmap: ${DateTime.Now - Clock} ms"$)
	#End If
	Return b4abmp
	#else if B4J
	If WriteableImage.IsInitialized = False Then
		WriteableImage.InitializeNewInstance("javafx.scene.image.WritableImage", Array(mWidth, mHeight))
	End If
	Dim writer As JavaObject = WriteableImage.RunMethod("getPixelWriter", Null)
	Dim PixelFormat As JavaObject
	PixelFormat.InitializeStatic("javafx.scene.image.PixelFormat")
	writer.RunMethod("setPixels", Array(0, 0, mWidth, mHeight, PixelFormat.RunMethod("getByteBgraPreInstance", Null), _
		mBuffer, 0, mWidth * 4))
	#if Stats
	Log($"Get Bitmap: ${DateTime.Now - Clock} ms"$)
	#End If
	Return WriteableImage
	#Else
	Dim no As NativeObject = Me
	Dim bmp As Bitmap = no.RunMethod("bufferToUIImage:::", Array(no.ArrayToNSData(mBuffer), mWidth, mHeight))
	Return bmp
	#end if
End Sub



#Region ************  Drawing methods ***************
'Draws a BCPath. Don't confuse with B4XPath or Path.
'Returns the created color brush.
Public Sub DrawPath(Path As BCPath, Color As Int, Filled As Boolean, StrokeWidth As Int) As BCBrush
	Return DrawPath2(Path, CreateBrushFromColor(Color), Filled, StrokeWidth)
End Sub

'Draws a line.
Public Sub DrawLine2 (X0 As Float, Y0 As Float, X1 As Float, Y1 As Float, Brush As BCBrush, StrokeWidth As Int) As BCBrush
'	Log($"${X0}, ${Y0}, ${X1}, ${Y1}"$)
	Dim PointsX(4), PointsY(4) As Float
	If CalcLinePoints(X0, Y0, X1, Y1, StrokeWidth, PointsX, PointsY) = False Then Return Brush
	If (X1 >= X0) <> (Y1 >= Y0) Then
		SwapPoint(PointsX, PointsY, 1, 3)
	End If
	DrawConvexQuadrilateral(PointsX, PointsY, Brush, True)
	Return Brush
End Sub

'Draws a BCPath. Don't confuse with B4XPath or Path.
'Non-full paths: Connection segments are drawn between each two lines. You can disable it by setting BCPath.DrawConnectionSegments to False.
'This will make the drawing twice as fast (in most cases it will be fast enough anyway).
Public Sub DrawPath2 (Path As BCPath, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As BCBrush
	If Path.Points.Size <= 1 Then Return Brush
	If Filled Then
		DrawFullPath(Path, Brush)
		Return Brush
	End If
	Dim PointsX(4), PointsY(4) As Float
	Dim TempPointsX(4), TempPointsY(4) As Float
	Dim lastx2, lasty2, lastx3, lasty3 As Float
	For i = 0 To Path.Points.Size - 2
		Dim CurrentPoint As InternalBCPathPointData = Path.Points.Get(i)
		Dim NextPoint As InternalBCPathPointData = Path.Points.Get(i + 1)
		CalcLinePoints(CurrentPoint.X, CurrentPoint.Y, NextPoint.X, NextPoint.Y, StrokeWidth, PointsX, PointsY)
		If i > 0 And Path.DrawConnectionSegments Then
			TempPointsX(0) = lastx3
			TempPointsY(0) = lasty3
			TempPointsX(1) = lastx2
			TempPointsY(1) = lasty2
			TempPointsX(2) = PointsX(0)
			TempPointsY(2) = PointsY(0)
			TempPointsX(3) = PointsX(1)
			TempPointsY(3) = PointsY(1)
			DrawConvexQuadrilateral(TempPointsX, TempPointsY, Brush, False)
		End If
		lastx2 = PointsX(2)
		lasty2 = PointsY(2)
		lastx3 = PointsX(3)
		lasty3 = PointsY(3)
		If (NextPoint.X >= CurrentPoint.X) <> (NextPoint.Y >= CurrentPoint.Y) Then
			SwapPoint(PointsX, PointsY, 1, 3)
		End If
		DrawConvexQuadrilateral(PointsX, PointsY, Brush, True)
	Next
	Return Brush
End Sub

Private Sub DrawFullPath(Path As BCPath, PaintSource As BCBrush)
	Path.PrepareForFilling
	Dim bounds As B4XRect = Path.FindBoundingRect
	Dim LeftColumns, RightColumns As List
	LeftColumns.Initialize
	RightColumns.Initialize
	Dim PointsX(2), PointsY(2) As Float
	Dim x0, y0, x1, y1 As Float
	Dim LastColumnData As InternalBCPathColumnData
	Dim LastColumn As InternalBCColumn = Null
	Dim NewColumn As InternalBCColumn = Null
	Dim ColumnSwitch As Boolean
	Dim FirstColumn As InternalBCColumn = Null
	Dim Start, EndI, StepI As Int
	If Path.InternalCounterClockWise Then
		Start = 0
		EndI = Path.Points.Size - 2
		StepI = 1
	Else
		Start = Path.Points.Size - 1
		EndI = 1
		StepI = -1
	End If
	For i = Start To EndI Step StepI
		Dim CurrentPoint As InternalBCPathPointData = Path.Points.Get(i)
		Dim NextPoint As InternalBCPathPointData = Path.Points.Get(i + StepI)
		x0 = CurrentPoint.X
		y0 = CurrentPoint.Y
		x1 = NextPoint.X
		y1 = NextPoint.Y
		If LastColumnData <> NextPoint.ColumnData Then
			LastColumnData = NextPoint.ColumnData
			NewColumn = CreateColumn(Max(0, LastColumnData.MinY - 2 + 0.5), Min(mHeight, LastColumnData.MaxY + 2 + 0.5)) 'adding one before the real start to avoid issues with antialiasing boundaries.
			NewColumn.LeftSide = y1 >= y0
			If NewColumn.LeftSide And LastColumnData.MinY <> LastColumnData.MaxY Then LeftColumns.Add(NewColumn) Else RightColumns.Add(NewColumn)
			ColumnSwitch = True
		Else
			ColumnSwitch = False
		End If
		PointsX(0) = x0
		PointsX(1) = x1
		PointsY(0) = y0
		PointsY(1) = y1
		If y1 <> y0 Then
			DrawWuLine(x0, y0, x1, y1, ShouldCheckBounds(PointsX, PointsY), NewColumn.LeftSide, NewColumn, NewColumn, PaintSource, False)
		End If
		If ColumnSwitch Then
			If LastColumn <> Null Then
				ColumnSwitchImpl(LastColumn, NewColumn, y0 + 0.5, y1 + 0.5)
			Else
				FirstColumn = NewColumn
			End If
			LastColumn = NewColumn
		End If
	Next
	
	NextPoint = Path.Points.Get(1)
	If FirstColumn.LeftSide <> LastColumn.LeftSide Then
		ColumnSwitchImpl(LastColumn, FirstColumn, y1 + 0.5, NextPoint.Y + 0.5)
	End If
	For y = Max(0, bounds.Top) To Min(mHeight, bounds.Bottom)
		For LeftI = 0 To LeftColumns.Size - 1
			Dim CLeft As InternalBCColumn = LeftColumns.Get(LeftI)
			If y >= CLeft.StartY + 2 And y <= CLeft.EndY - 2 Then
				'relevant left side
				#if B4i
				Dim LeftX As Float = Bit.FastArrayGetFloat(CLeft.Values, y - CLeft.StartY)
				#else
				Dim LeftX As Float = CLeft.Values(y - CLeft.StartY)
				#End If
				Dim MinRight As Float = 9999999
				For RightI = 0 To RightColumns.Size - 1
					Dim CRight As InternalBCColumn = RightColumns.Get(RightI)
					If y >= CRight.StartY + 2 And y <= CRight.EndY - 2 Then
						#if B4i
						Dim RightX As Float = Bit.FastArrayGetFloat(CRight.Values, y - CRight.StartY)
						#else
						Dim RightX As Float = CRight.Values(y - CRight.StartY)
						#end if
						If RightX > LeftX Then
							MinRight = Min(RightX, MinRight)
						End If
					End If
				Next
				
				If MinRight > LeftX And MinRight < 9999999 Then
					If y = CLeft.StartY Or y = CLeft.EndY Then
						LeftX = LeftX + 0.011
						MinRight = MinRight + 0.011
					End If
					Dim ileft As Int = Floor(LeftX) + 1
					Dim iright As Int = Floor(MinRight) + 1
					FillHorizontalLine(ileft, iright, y, PaintSource)
				End If
			End If
		Next
	Next
End Sub

Private Sub ColumnSwitchImpl(LastColumn As InternalBCColumn, NewColumn As InternalBCColumn, y0 As Int, y1 As Int)
	Dim pos As Int
	If y1 > y0 Then
		pos = y0 + 1
		If y0 < LastColumn.StartY Or pos >= LastColumn.EndY Or y0 < NewColumn.StartY Or pos >= NewColumn.EndY Then Return
	Else
		pos = y0 - 1
		If pos < LastColumn.StartY Or y0 >= LastColumn.EndY Or pos < NewColumn.StartY Or y0 >= NewColumn.EndY Then Return
	End If
		#if B4i
		Dim x0 As Float = Bit.FastArrayGetFloat(LastColumn.Values, pos - LastColumn.StartY)
		Dim x1 As Float = Bit.FastArrayGetFloat(NewColumn.Values, pos - NewColumn.StartY)
		Dim offset As Float
		If x1 > x0 Then
			offset = -0.01
		Else If x1 < x0  Then
			offset = 0.01
		End If
		Bit.FastArraySetFloat(LastColumn.Values, y0 - LastColumn.StartY, Bit.FastArrayGetFloat(LastColumn.Values, (y0 - LastColumn.StartY))  + offset)
		#else
	Dim x0 As Float = LastColumn.Values(pos - LastColumn.StartY)
	Dim x1 As Float = NewColumn.Values(pos - NewColumn.StartY)
	If x1 > x0 Then
		LastColumn.Values(y0 - LastColumn.StartY) = LastColumn.Values(y0 - LastColumn.StartY) - 0.01
	Else If x1 < x0  Then
		LastColumn.Values(y0 - LastColumn.StartY) = LastColumn.Values(y0 - LastColumn.StartY) + 0.01
	End If
	#End If
		
End Sub

'Creates a BCBrush from the given color. You can reuse the brush.
Public Sub CreateBrushFromColor(Color As Int) As BCBrush
	Dim bc As BitmapCreator
	bc.Initialize(mWidth, 1)
	Dim a As ARGBColor
	ColorToARGB(Color, a)
	Dim pm As PremultipliedColor
	ARGBToPremultipliedColor(a, pm)
	For i = 0 To bc.mWidth * 4 - 1 Step 4
		#if B4i
		Bit.FastArraySetByte(bc.mBuffer, i + ri, pm.r)
		Bit.FastArraySetByte(bc.mBuffer, i + gi, pm.g)
		Bit.FastArraySetByte(bc.mBuffer, i + bi, pm.b)
		Bit.FastArraySetByte(bc.mBuffer, i + ai, pm.a)
		#else
		bc.mBuffer(i + ri) = pm.r
		bc.mBuffer(i + gi) = pm.g
		bc.mBuffer(i + bi) = pm.b
		bc.mBuffer(i + ai) = pm.a
		#End If
	Next
	Dim source As BCBrush
	source.Source = bc
	source.IsColorSource = True
	source.BlendBorders = True
	source.ColorPM = pm
	Return source
End Sub

'Creates a BCBrush from the given bitmap. You can reuse the brush.
Public Sub CreateBrushFromBitmap(Bmp As B4XBitmap) As BCBrush
	Dim bc As BitmapCreator
	bc.Initialize(Bmp.Width, Bmp.Height)
	bc.CopyPixelsFromBitmap(Bmp)
	Return CreateBrushFromBitmapCreator(bc)
End Sub

'Creates a BCBrush from the given BitmapCreator. You can reuse the brush.
'Note that the BitmapCreator is not copied.
Public Sub CreateBrushFromBitmapCreator(BC As BitmapCreator) As BCBrush
	Dim source As BCBrush
	source.Source = BC
	source.BlendBorders = True
	Return source
End Sub

'Asynchronously draws a line. Returns a DrawTask that should be added to the list of drawing tasks.
Public Sub AsyncDrawLine (X0 As Float, Y0 As Float, X1 As Float, Y1 As Float, Brush As BCBrush, StrokeWidth As Int) As DrawTask
	Return CreateCanvasDrawTask(1, Brush, False, Array As Float(X0, Y0, X1, Y1, StrokeWidth))
End Sub

'Asynchronously draws a circle. Returns a DrawTask that should be added to the list of drawing tasks.
Public Sub AsyncDrawCircle (X As Float, Y As Float, Radius As Float, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As DrawTask
	Return CreateCanvasDrawTask(2, Brush, Filled, Array As Float(X, Y, Radius, StrokeWidth))
End Sub

'Asynchronously draws an arc. Returns a DrawTask that should be added to the list of drawing tasks.
Public Sub AsyncDrawArc (X As Float, Y As Float, Radius As Float, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int, _
		StartingAngle As Float, EndAngle As Float) As DrawTask
	Return CreateCanvasDrawTask(6, Brush, Filled, Array As Float(X, Y, Radius, StrokeWidth, StartingAngle, EndAngle))
End Sub

'Asynchronously draws a rectangle. Returns a DrawTask that should be added to the list of drawing tasks.
Public Sub AsyncDrawRect (Rect As B4XRect, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As DrawTask
	Dim dt As DrawTask = CreateCanvasDrawTask(3, Brush, Filled, Array As Float(StrokeWidth))
	dt.Source = Rect
	Return dt
End Sub

'Asynchronously draws a rectangle with round corners. Returns a DrawTask that should be added to the list of drawing tasks.
Public Sub AsyncDrawRectRounded (Rect As B4XRect, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int, CornersRadius As Int) As DrawTask
	Dim dt As DrawTask = CreateCanvasDrawTask(4, Brush, Filled, Array As Float(StrokeWidth, CornersRadius))
	dt.Source = Rect
	Return dt
End Sub

'Asynchronously draws a path. Returns a DrawTask that should be added to the list of drawing tasks.
'Note that you shouldn't modify the path while it is being drawn. You can use BCPath.Clone to create a copy.
Public Sub AsyncDrawPath (Path As BCPath, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As DrawTask
	Dim dt As DrawTask = CreateCanvasDrawTask(5, Brush, Filled, Array As Float(StrokeWidth))
	dt.Source = Path
	Return dt
End Sub

Private Sub DrawCanvasAsync (dt As DrawTask) 'ignore called from native code.
	Dim code As Int = dt.CanvasTask.Code
	Dim values() As Float = dt.CanvasTask.Values
	Select code
		Case 1
			DrawLine2(values(0), values(1), values(2), values(3), dt.CanvasTask.Brush, values(4))
		Case 2
			DrawCircle2(values(0), values(1), values(2), dt.CanvasTask.Brush, dt.CanvasTask.Filled, values(3))
		Case 3
			DrawRect2(dt.Source, dt.CanvasTask.Brush, dt.CanvasTask.Filled, values(0))
		Case 4
			DrawRectRounded2(dt.Source, dt.CanvasTask.Brush, dt.CanvasTask.Filled, values(0), values(1))
		Case 5
			DrawPath2(dt.Source, dt.CanvasTask.Brush, dt.CanvasTask.Filled, values(0))
		Case 6
			DrawArc2(values(0), values(1), values(2), dt.CanvasTask.Brush, dt.CanvasTask.Filled, values(3), values(4), values(5))
	End Select
End Sub

Private Sub CreateCanvasDrawTask(Code As Int, Brush As BCBrush, Filled As Boolean ,Values() As Float) As DrawTask
	Dim dt As DrawTask
	Dim ct As InternalCanvasDrawTask
	ct.Brush = Brush
	ct.Values = Values
	ct.Code = Code
	ct.Filled = Filled
	dt.IsCanvasTask = True
	dt.CanvasTask = ct
	dt.TargetBC = Me
	Return dt
End Sub

'Draws a line. Returns the color brush.
Public Sub DrawLine (X0 As Float, Y0 As Float, X1 As Float, Y1 As Float, Color As Int, StrokeWidth As Int) As BCBrush
	Return DrawLine2(X0, Y0, X1, Y1, CreateBrushFromColor(Color), StrokeWidth)
End Sub

Private Sub CalcLinePoints(X0 As Float, Y0 As Float, X1 As Float, Y1 As Float, StrokeWidth As Int, PointsX() As Float, PointsY() As Float) As Boolean
	Dim TotalDX As Float = X1 - X0
	Dim TotalDY As Float = Y1 - Y0
	If TotalDX = 0 And TotalDY = 0 Then Return False
	Dim halfwidth As Float = (StrokeWidth) / 2
	Dim alpha As Float = ATan2(Abs(TotalDY), Abs(TotalDX))
	Dim offsetx, offsety As Float
	offsetx = halfwidth * Sin(alpha)
	offsety = halfwidth * Cos(alpha)
	If Y1 < Y0 Then offsety = -offsety
	If X1 < X0 Then offsetx = -offsetx
	PointsX(0) = X0 + offsetx
	PointsX(1) = X0 - offsetx
	PointsX(2) = X1 - offsetx
	PointsX(3) = X1 + offsetx
	PointsY(0) = Y0 - offsety
	PointsY(1) = Y0 + offsety
	PointsY(2) = Y1 + offsety
	PointsY(3) = Y1 - offsety
	Return True
End Sub


Private Sub LogPoints(Msg As String, PointsX() As Float, PointsY() As Float) 'ignore
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(Msg)
	For i = 0 To PointsX.Length - 1
		sb.Append($",  ${i}: $1.1{PointsX(i)}x$1.1{PointsY(i)}"$)
	Next
	Log(sb.ToString)
End Sub

'0 ------- 3
'|		   |
'|		   |
'1 --------2

Private Sub DrawConvexQuadrilateral(PointsX() As Float, PointsY() As Float, Brush As BCBrush, Sorted As Boolean)
	If Sorted = False Then
		SortPoints(PointsX, PointsY)
	End If
  	Dim x0, y0, x1, y1, x2, y2, x3, y3 As Float
	x0 = PointsX(0): x1 = PointsX(1): x2 = PointsX(2): x3 = PointsX(3)
	y0 = PointsY(0): y1 = PointsY(1): y2 = PointsY(2): y3 = PointsY(3)
	Dim MinY As Float = Min(y0, Min(y1, Min(y2, y3)))
	Dim MaxY As Float = Max(y0, Max(y1, Max(y2, y3)))
	PrepareColumns(2)
	Dim columnleft As InternalBCColumn = ReadyColumns.Get(0)
	Dim columnright As InternalBCColumn = ReadyColumns.Get(1)
	Dim CheckBounds As Boolean = ShouldCheckBounds(PointsX, PointsY)
	MinY = Min(mHeight - 1, Max(0, Round(MinY)))
	MaxY = Min(mHeight - 1, Max(0, Round(MaxY)))
	#if B4i
	Bit.FastArraySetFloat(columnright.Values, MinY, 0)
	Bit.FastArraySetFloat(columnleft.Values, MinY, 0)
	#Else
	columnright.Values(MinY) = 0
	columnright.Values(MaxY) = 0
	#End If
	If y1 <> y0 Then DrawWuLine(x0, y0, x1, y1, CheckBounds, y1 > y0, columnleft, columnright, Brush, True)
	If y2 <> y1 Then DrawWuLine(x1, y1, x2, y2, CheckBounds, y2 > y1, columnleft, columnright, Brush, True)
	If y3 <> y2 Then DrawWuLine(x2, y2, x3, y3, CheckBounds, y3 >= y2, columnleft, columnright, Brush, True)
	If y0 <> y3 Then DrawWuLine(x3, y3, x0, y0, CheckBounds, y0 >= y3, columnleft, columnright, Brush, True)
	For y = MinY To MaxY
		#if B4i
		Dim xstart As Int = Floor(Bit.FastArrayGetFloat(columnleft.Values, y)) + 1
		Dim xend As Int = Floor(Bit.FastArrayGetFloat(columnright.Values, y)) + 1
		#else
		Dim xstart As Int = Floor(columnleft.Values(y)) + 1
		Dim xend As Int = Floor(columnright.Values(y)) + 1
		#End If
		If xend > xstart Then
			FillHorizontalLine(xstart, xend, y, Brush)
		End If
	Next
End Sub

Private Sub FillHorizontalLine (xstart As Int, xend As Int, y As Int, Brush As BCBrush)
	Dim cp As Int = xstart * 4 + y * mWidth * 4
	Dim Length As Int = xend - xstart
	If Brush.IsColorSource Then
		Bit.ArrayCopy(Brush.Source.mBuffer, 0, mBuffer, cp, Length * 4)
		Return
	End If
	Dim SrcX As Int = (xstart - Brush.SrcOffsetX) Mod Brush.Source.mWidth
	Dim SrcY As Int = (y - Brush.SrcOffsetY) Mod Brush.Source.mHeight
	If SrcX < 0 Then SrcX = SrcX + Brush.Source.mWidth
	If SrcY < 0 Then SrcY = SrcY + Brush.Source.mHeight
	If Brush.BlendAll = False Then
		If Brush.Source.mWidth - SrcX > Length Then
			Dim SourceCP As Int = SrcX * 4 + SrcY * Brush.Source.mWidth * 4
			Bit.ArrayCopy(Brush.Source.mBuffer, SourceCP, mBuffer, cp, Length * 4)
		Else
			Do While Length > 0
				Dim count As Int = Min(Length, Brush.Source.mWidth - SrcX)
				Dim SourceCP As Int = SrcX * 4 + SrcY * Brush.Source.mWidth * 4
				Bit.ArrayCopy(Brush.Source.mBuffer, SourceCP, mBuffer, cp, count * 4)
				cp = cp + count * 4
				SrcX = (SrcX + count) Mod Brush.Source.mWidth
				Length = Length - count
			Loop
		End If
	Else
		For x = xstart To xend - 1
			#if B4i
			Dim cp1 As Int = ((x - xstart + SrcX) Mod Brush.Source.mWidth) * 4 + SrcY * Brush.Source.mWidth * 4
			Dim cp2 As Int = x * 4 + y * mWidth * 4
			Dim a1 As Byte = Bit.FastArrayGetByte(Brush.Source.mBuffer, cp1 + ai)
			Dim r1 As Byte = Bit.FastArrayGetByte(Brush.Source.mBuffer, cp1 + ri)
			Dim g1 As Byte = Bit.FastArrayGetByte(Brush.Source.mBuffer, cp1 + gi)
			Dim b1 As Byte = Bit.FastArrayGetByte(Brush.Source.mBuffer, cp1 + bi)
			If a1 <> UnsignedFF Then
				If a1 = 0 Then Continue
				Dim a2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + ai)
				Dim r2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + ri)
				Dim g2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + gi)
				Dim b2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + bi)
				Dim SrcAF As Float = 1 - (a1 / 255)
				r1 =  r1 + SrcAF *  r2
				g1 =  g1 + SrcAF *  g2
				b1 =  b1 + SrcAF *  b2
				a1 =  a1 + SrcAF *  a2
			End If
			Bit.FastArraySetByte(mBuffer, cp2 + ri, r1)
			Bit.FastArraySetByte(mBuffer, cp2 + gi, g1)
			Bit.FastArraySetByte(mBuffer, cp2 + bi, b1)
			Bit.FastArraySetByte(mBuffer, cp2 + ai, a1)
			#else
			BlendPixel(Brush.Source, (x - xstart + SrcX) Mod Brush.Source.mWidth, SrcY, x, y)
			#End If
		Next
	End If
	
End Sub



Private Sub DrawWuLine (X0 As Float, Y0 As Float, X1 As Float, Y1 As Float, CheckBounds As Boolean, LeftSide As Boolean, _
		columnleft As InternalBCColumn, columnright As InternalBCColumn, PaintSource As BCBrush, SkipEdgesIfNotSteep As Boolean)
	Dim column As InternalBCColumn
	If LeftSide Then column = columnleft Else column = columnright
	Dim MinX As Float = Max(-1, Min(mWidth - 1 ,Min(X0, X1)))
	Dim MaxX As Float = Min(mWidth - 1, Max(0, Max(X0, X1)))
	Dim steep As Boolean =  Abs(Y1 - Y0) > Abs(X1 - X0)
	Dim temp As Float
	If steep Then
		temp = X0
		X0 = Y0
		Y0 = temp
		temp = X1
		X1 = Y1
		Y1 = temp
	End If
	If X0 > X1 Then
		temp = X0
		X0 = X1
		X1 = temp
		temp = Y0
		Y0 = Y1
		Y1 = temp
	End If
	Dim dy As Float = Y1 - Y0
	Dim dx As Float = X1 - X0
	Dim gradient As Float
	If dx = 0 Then gradient = 1 Else gradient = dy / dx
	Dim x As Float
	Dim ix, iy As Int
	Dim fp As Float
	Dim intery As Float
	Dim t As Float
	Dim MinY As Int = Min(Y0, Y1)
	Dim MaxY As Int = Max(Y0, Y1)
	
	If steep Then
		Dim iystart As Int = Round(X0)
		Dim iyend As Int = Round(X1)
		intery = Y0 - (X0 - iystart) * gradient
		For iy = iystart To iyend
			ix = Floor(intery)
			If CheckBounds = False Or (intery >= 0 And intery + 1 < mWidth And iy >= column.StartY And iy < column.EndY) Then
				fp = intery - ix
				t = Max(MinX, Min(MaxX, intery))
'				Log($"${iy}, ${t}, ${intery}, ${ix}, ${1 - fp}"$)
				If LeftSide Then
					If 1 - fp > 0.1 And ix >= MinY Then DrawAntiAliasBorder(ix, iy, 1 - fp, PaintSource, False)
				Else
					If fp > 0.1 And ix + 1 <= MaxY Then DrawAntiAliasBorder(ix + 1, iy, fp, PaintSource, False)
				End If
				#if B4i
				Bit.FastArraySetFloat(column.Values, iy - column.StartY, t)
				#else
				column.Values(iy - column.StartY) = t
				#End If
			Else if iy >= column.StartY And iy < column.EndY Then
				t = Max(MinX, Min(MaxX, intery))
				#if B4i
				Bit.FastArraySetFloat(column.Values, iy - column.StartY, t)
				#else
				column.Values(iy - column.StartY) = t
				#End If
			End If
			intery = intery + gradient
		Next
	Else
		Dim SignY As Int
		If dy > 0 Then SignY = 1 Else SignY = -1
		x = X0
		Dim iystart As Int = Round(Y0)
		Dim iyend As Int = Round(Y1)
		Dim g As Float = 1/gradient
		x = x - (Y0 - iystart) * g
		g = g * SignY
		For iy = iystart To iyend Step SignY
			t = Max(MinX, Min(x, MaxX))
			If CheckBounds Then
				If iy >= column.StartY And iy < column.EndY Then
					#if B4i
					Bit.FastArraySetFloat(column.Values, iy - column.StartY, t)
					#else
					column.Values(iy - column.StartY) = t
					#End If
				End If
			Else
				#if B4i
				Bit.FastArraySetFloat(column.Values, iy - column.StartY, t)
				#else
				column.Values(iy - column.StartY) = t
				#End If
			End If
			x = x + g
		Next
		
		Dim ixstart As Int = Round(X0)
		intery = Y0 - (X0 - ixstart) * gradient
		Dim IXEnd As Int = Round(X1)
		Dim SkipLength As Int = 0
		If SkipEdgesIfNotSteep Then
			intery = intery + gradient
			SkipLength = 1
		End If
		For ix = ixstart + SkipLength To IXEnd - SkipLength
			iy = Floor(intery)
			If CheckBounds = False Or (ix >= 0 And ix < mWidth And iy >= column.StartY And iy + 1 < column.EndY) Then
				fp = intery - iy
					#if B4i
				Dim ciy As Float = Bit.FastArrayGetFloat(column.Values, iy - column.StartY)
				Dim ciy1 As Float = Bit.FastArrayGetFloat(column.Values, iy + 1 - column.StartY)
					#else
				Dim ciy As Float = column.Values(iy - column.StartY)
				Dim ciy1 As Float = column.Values(iy + 1 - column.StartY)
					#End If
				If iy >= MinY And ((LeftSide And ix <= ciy + 1) Or (LeftSide = False And ix >= ciy - 1)) Then
					If 1 - fp > 0.1 Then DrawAntiAliasBorder(ix, iy, 1 - fp, PaintSource, False)
				End If
				If iy + 1 <= MaxY And ((LeftSide And ix <= ciy1 + 1) Or (LeftSide = False And ix >= ciy1 - 1)) Then
					If fp > 0.1 Then DrawAntiAliasBorder(ix, iy + 1, fp, PaintSource, False)
				End If
			End If
			intery = intery + gradient
		Next
	End If
End Sub

Private Sub ShouldCheckBounds(PointsX() As Float, PointsY() As Float) As Boolean
	For i = 0 To PointsY.Length - 1
		If PointsX(i) < 1 Or PointsX(i) >= mWidth - 1 Or PointsY(i) < 1 Or PointsY(i) >= mHeight - 1 Then
			Return True
		End If
	Next
	Return False
End Sub

Private Sub SortPoints(PointsX() As Float, PointsY() As Float)
	If COrientation(PointsX, PointsY, 0, 1, 2) < 0 Then
		If COrientation(PointsX, PointsY, 0, 2, 3) < 0 Then
			Return
		Else If COrientation(PointsX, PointsY, 0, 1, 3) < 0 Then
			SwapPoint(PointsX, PointsY, 3, 2)
		Else
			SwapPoint(PointsX, PointsY, 0, 3)
		End If
	Else if COrientation(PointsX, PointsY, 0, 2, 3) < 0 Then
		If COrientation(PointsX, PointsY, 0, 1, 3) < 0 Then
			SwapPoint(PointsX, PointsY, 1, 2)
		Else
			SwapPoint(PointsX, PointsY, 0, 1)
		End If
	Else
		SwapPoint(PointsX, PointsY, 0, 2)
	End If
End Sub

Private Sub COrientation (PointsX() As Float, PointsY() As Float, a As Int, b As Int, c As Int) As Int
	Return CrossProductZ(PointsX, PointsY, a, b) + _
		CrossProductZ(PointsX, PointsY, b, c) + _
		CrossProductZ(PointsX, PointsY, c, a)
End Sub

Private Sub CrossProductZ(PointsX() As Float, PointsY() As Float, a As Int, b As Int) As Float
	Return PointsX(a) * PointsY(b) - PointsY(a) * PointsX(b)
End Sub

Private Sub SwapPoint(PointsX() As Float, PointsY() As Float, i1 As Int, i2 As Int)
	Dim x As Float = PointsX(i2)
	Dim y As Float = PointsY(i2)
	PointsX(i2) = PointsX(i1)
	PointsY(i2) = PointsY(i1)
	PointsX(i1) = x
	PointsY(i1) = y
End Sub

Private Sub PrepareColumns(NumberOfColumns As Int)
	If ReadyColumns.IsInitialized = False Then
		ReadyColumns.Initialize
	End If
	Do While ReadyColumns.Size < NumberOfColumns
		ReadyColumns.Add(CreateColumn(0, mHeight))
	Loop
End Sub

Private Sub CreateColumn(StartY As Int, EndY As Int) As InternalBCColumn
	Dim c As InternalBCColumn
	Dim height As Int = Max(0, EndY - StartY)
	c.Initialize
	#if B4i
	Dim col1(height * 4) As Byte
	#else
	Dim col1(height) As Float
	#End If
	c.Values = col1
	c.StartY = StartY
	c.EndY = EndY
	Return c
End Sub


'Draws a a circle. Returns the color brush.
Public Sub DrawCircle (X As Float, Y As Float, Radius As Float, Color As Int, Filled As Boolean, StrokeWidth As Int) As BCBrush
	Return DrawCircle2(X, Y, Radius, CreateBrushFromColor(Color), Filled, StrokeWidth)		
End Sub

'Draws a circle.
Public Sub DrawCircle2 (X As Float, Y As Float, Radius As Float, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As BCBrush
	Return DrawCircleImpl(X, Y, Radius, Brush, Filled, StrokeWidth, 0, 0, 0, 0)
End Sub

Private Sub DrawCircleImpl (fX As Float, fY As Float, fRadius As Float, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int, _
		ExtendX1 As Int, ExtendX2 As Int, ExtendY1 As Int, ExtendY2 As Int) As BCBrush
	Dim x = Round(fX), y = Round(fY), Radius = Round(fRadius) As Int
	If x + Radius + ExtendX2 < 0 Or x - Radius - ExtendX1 >= mWidth Or y + Radius + ExtendY2 < 0 Or y - Radius - ExtendY1 >= mHeight Then Return Brush
	Dim CheckBounds As Boolean = x - Radius - ExtendX1 < 0 Or x + Radius + ExtendX2 >= mWidth Or y - Radius - ExtendY1 < 0 Or y + Radius + ExtendY2 >= mHeight
	PrepareColumns(2)
	Dim StartY1 As Int = Max(0, y - Radius - ExtendY1 + 1)
	Dim EndY1 As Int = Min(mHeight - 1, Y - ExtendY1)
	Dim StartY2 As Int = Max(0, y + 1 + ExtendY2)
	Dim EndY2 As Int = Min(mHeight, Y + Radius + ExtendY2) - 1
	If StrokeWidth >= Radius Then Filled = True
	If Filled Then
		Dim col As InternalBCColumn = ReadyColumns.Get(0)
		DrawWuCircle(X, Y, Radius - 1, CheckBounds, False, col, Brush, ExtendX1, ExtendX2, ExtendY1, ExtendY2)
		For row = StartY1 To EndY1
			#if B4i
			Dim dx As Int = Bit.FastArrayGetFloat(col.Values, row)
			#else
			Dim dx As Int = col.Values(row)
			#end if
			Dim X1 As Int = Max(0, x - dx - ExtendX1)
			Dim x2 As Int = Min(mWidth - 1, x + dx + ExtendX2)
			If x2 >= X1 Then
				FillHorizontalLine(X1, x2 + 1, row, Brush)
			End If
		Next
		For row = StartY2 To EndY2
			#if B4i
			Dim dx As Int = Bit.FastArrayGetFloat(col.Values, row)
			#else
			Dim dx As Int = col.Values(row)
			#end if
			Dim X1 As Int = Max(0, x - dx - ExtendX1)
			Dim x2 As Int = Min(mWidth - 1, x + dx + ExtendX2)
			If x2 >= X1 Then
				FillHorizontalLine(X1, x2 + 1, row, Brush)
			End If
		Next
		If ExtendY1 > 0 Then
			X1 = Max(0, x - ExtendX1 - Radius + 1)
			x2 = Min(mWidth, x + ExtendX2 + Radius)
			For row = Max(0, y - ExtendY1 + 1) To Min(mHeight - 1, Y + ExtendY2)
				FillHorizontalLine(X1, x2, row, Brush)
			Next
		End If
		
	Else
		Dim col1 As InternalBCColumn = ReadyColumns.Get(0)
		Dim col2 As InternalBCColumn = ReadyColumns.Get(1)
		
		Dim SmallRadius As Int =  Radius - StrokeWidth
		DrawWuCircle(X, Y, Radius - 1, CheckBounds, False, col1, Brush, ExtendX1, ExtendX2, ExtendY1, ExtendY2)
		DrawWuCircle(X, Y, SmallRadius, CheckBounds, True, col2, Brush, ExtendX1, ExtendX2, ExtendY1, ExtendY2)
		For row = StartY1 To EndY1
			#if B4i
			Dim dx As Int = Bit.FastArrayGetFloat(col1.Values, row)
			#else
			Dim dx As Int = col1.Values(row)
			#end if
			Dim X1 As Int = Max(0, x - dx - ExtendX1)
			Dim x2 As Int = Min(mWidth - 1, x + dx + ExtendX2)
			If x2 >= X1 Then
				If y - row - ExtendY1 < SmallRadius Then
					#if B4i
					Dim dx2 As Int = Bit.FastArrayGetFloat(col2.Values, row)
					#else
					Dim dx2 As Int = col2.Values(row)
					#end if
					Dim sx1 As Int = Min(mWidth, Max(0, x - dx2 - ExtendX1))
					Dim sx2 As Int = Max(0, Min(mWidth, x + dx2 + ExtendX2))
					If sx1 > X1 Then
						FillHorizontalLine(X1, sx1, row, Brush)
					End If
					If sx2 < x2 Then
						FillHorizontalLine(sx2 + 1, x2 + 1, row, Brush)
					End If
				Else
					FillHorizontalLine(X1, x2 + 1, row, Brush)
				End If
			End If
		Next
		For row = StartY2 To EndY2
			#if B4i
			Dim dx As Int = Bit.FastArrayGetFloat(col1.Values, row)
			#else
			Dim dx As Int = col1.Values(row)
			#end if
			Dim X1 As Int = Max(0, x - dx - ExtendX1)
			Dim x2 As Int = Min(mWidth - 1, x + dx + ExtendX2)
			If x2 >= X1 Then
				If row - ExtendY2 - y < SmallRadius Then
					#if B4i
					Dim dx2 As Int = Bit.FastArrayGetFloat(col2.Values, row)
					#else
					Dim dx2 As Int = col2.Values(row)
					#end if
					Dim sx1 As Int = Min(mWidth, Max(0, x - dx2 - ExtendX1))
					Dim sx2 As Int = Max(0, Min(mWidth, x + dx2 + ExtendX2))
					If sx1 > X1 Then
						FillHorizontalLine(X1, sx1, row, Brush)
					End If
					If sx2 < x2 Then
						FillHorizontalLine(sx2 + 1, x2 + 1, row, Brush)
					End If
				Else
					FillHorizontalLine(X1, x2 + 1, row, Brush)
				End If
			End If
		Next
		If ExtendY1 > 0 Then
			Dim Left As Int = x - ExtendX1 - Radius + 1
			Dim Right As Int = x + ExtendX2 + Radius
			Dim lfixed As Int = Max(0, Left)
			Dim rfixed As Int = Min(mWidth, Right)
			Dim lengthleft As Int = Min(StrokeWidth, Left + StrokeWidth)
			Dim lengthright As Int = Min(StrokeWidth, mWidth + StrokeWidth - Right)
			For row = Max(0, y - ExtendY1 + 1) To Min(mHeight - 1, Y + ExtendY2)
				If lengthleft > 0 Then
					FillHorizontalLine(lfixed, lfixed + lengthleft, row, Brush)
				End If
				If lengthright > 0 Then
					FillHorizontalLine(rfixed - lengthright, rfixed, row, Brush)
				End If
			Next
		End If
	End If
	Return Brush
End Sub

Private Sub DrawWuCircle (X0 As Int, Y0 As Int, Radius As Int, CheckBounds As Boolean, Inner As Boolean, _
		column As InternalBCColumn, PaintSource As BCBrush, ExtendX1 As Int, ExtendX2 As Int, ExtendY1 As Int, ExtendY2 As Int)
	Dim s As Int = Sin(cPI / 4) * Radius + 0.5
	Dim c As Int = Cos(cPI / 4) * Radius + 0.5
	Dim r2 As Float = Radius * Radius
	Dim x, y As Float
	Dim ix, iy As Int
	For iy = 0 To Radius
		x = Sqrt(r2 - iy * iy)
		ix = x
		If CheckBounds = False Or (Y0 - iy - ExtendY1 >= 0 And Y0 - iy - ExtendY1 < mHeight) Then
			#if B4i
			Bit.FastArraySetFloat(column.Values, Y0 - iy - ExtendY1, ix)
			#else
			column.Values(Y0 - iy - ExtendY1) = ix
			#End If
		End If
		If CheckBounds = False Or (Y0 + iy + ExtendY2 >= 0 And Y0 + iy + ExtendY2 < mHeight) Then
			#if B4i
			Bit.FastArraySetFloat(column.Values, Y0 + iy + ExtendY2, ix)
			#else
			column.Values(Y0 + iy + ExtendY2) = ix
			#End If
		End If
		If iy <= s Then
			Dim fp As Float = x - ix
			If Inner Then
				If 1 - fp > 0.1 Then
					DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 - iy - ExtendY1, 1 - fp, PaintSource, CheckBounds)
					DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 - iy - ExtendY1, 1 - fp, PaintSource, CheckBounds)
					DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 + iy + ExtendY2, 1 - fp, PaintSource, CheckBounds)
					DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 + iy + ExtendY2, 1 - fp, PaintSource, CheckBounds)
				End If
			Else if fp > 0.1 Then
				DrawAntiAliasBorder(X0 + ix + 1 + ExtendX2, Y0 - iy - ExtendY1, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 + ix + 1 + ExtendX2, Y0 + iy + ExtendY2, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - 1 - ExtendX1, Y0 + iy + ExtendY2, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - 1 - ExtendX1, Y0 - iy - ExtendY1, fp, PaintSource, CheckBounds)
			End If
		End If
	Next
	For ix = c To 0 Step - 1
		y = Sqrt(r2 - ix * ix)
		iy = y
		Dim fp As Float = y - iy
		If Inner Or ix = 0 Then
			If 1 - fp > 0.1 Then
				DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 + iy + ExtendY2, 1 - fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 - iy - ExtendY1, 1 - fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 + iy + ExtendY2, 1 - fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 - iy - ExtendY1, 1 - fp, PaintSource, CheckBounds)
			End If
		Else
			If fp > 0.1 Then
				DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 + iy + 1 + ExtendY2, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 + iy + 1 + ExtendY2, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 + ix + ExtendX2, Y0 - iy - 1 - ExtendY1, fp, PaintSource, CheckBounds)
				DrawAntiAliasBorder(X0 - ix - ExtendX1, Y0 - iy - 1 - ExtendY1, fp, PaintSource, CheckBounds)
			End If
		End If
	Next
End Sub

'Draws an arc and returns the created brush.
'X / Y - Center position.
'Radius - Arc radius.
'Color - Drawing color.
'Filled - Whether to fill the arc or not.
'StrokeWidth - Stroke width (for non-full shapes).
'StartingAngle - Measured in degrees, starting from hour 3.
'SweepAngle - Measured in degrees. Positive is clockwise.
Public Sub DrawArc (X As Float, Y As Float, Radius As Float, Color As Int, Filled As Boolean, StrokeWidth As Int, StartingAngle As Float, SweepAngle As Float) As BCBrush
	Return DrawArc2(X, Y, Radius, CreateBrushFromColor(Color), Filled, StrokeWidth, StartingAngle, SweepAngle)
End Sub

'Similar to DrawArc. Expects a BCBrush instead of a color value.
Public Sub DrawArc2 (X As Float, Y As Float, Radius As Float, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int, StartingAngle As Float, SweepAngle As Float) As BCBrush
	If Abs(SweepAngle) >= 360 Then
		Return DrawCircle2(X, Y, Radius, Brush, Filled, StrokeWidth)
	End If
	#if B4i
	StartingAngle = Bit.FMod(StartingAngle, 360)
	#else
	StartingAngle = StartingAngle Mod 360
	#End If
	If StartingAngle < 0 Then StartingAngle = StartingAngle + 360
	#if B4i
	Dim EndAngle As Float = Bit.FMod((StartingAngle + SweepAngle), 360)
	#else
	Dim EndAngle As Float = (StartingAngle + SweepAngle) Mod 360
	#End If
	If EndAngle <= 0 Then EndAngle = EndAngle + 360
	If SweepAngle < 0 Then
		Dim t As Float = StartingAngle
		StartingAngle = EndAngle
		EndAngle = t
	End If
	Radius = Round(Radius)
	If StartingAngle > EndAngle Then
		DrawArc2(X, Y, Radius, Brush, Filled, StrokeWidth, StartingAngle, 360 - StartingAngle)
		Return DrawArc2(X, Y, Radius, Brush, Filled, StrokeWidth, 0, EndAngle)
	End If
	
'	Log($"${StartingAngle} -> ${EndAngle}"$)
	Dim ix = Round(X), iy = Round(Y), iRadius = Round(Radius) As Int
	If StrokeWidth >= iRadius Then Filled = True
	If Filled Then
		StrokeWidth = iRadius
	End If
	If ix + iRadius < 0 Or ix - iRadius >= mWidth Or iy + iRadius < 0 Or iy - iRadius >= mHeight Or (EndAngle - StartingAngle) = 0 Or SweepAngle = 0 Then Return Brush
	Dim CheckBounds As Boolean = ix - iRadius < 0 Or ix + iRadius >= mWidth Or iy - iRadius < 0 Or iy + iRadius >= mHeight
	
	PrepareColumns(4)
	Dim ColInnerLeft As InternalBCColumn = ReadyColumns.Get(0)
	Dim ColInnerRight As InternalBCColumn = ReadyColumns.Get(1)
	Dim ColOuterLeft As InternalBCColumn = ReadyColumns.Get(2)
	Dim ColOuterRight As InternalBCColumn = ReadyColumns.Get(3)
	Dim StartY1 As Int = Max(0, iy - Radius)
	Dim EndY1 As Int = Min(mHeight - 1, iy + Radius)
	For i = StartY1 To EndY1
	#if B4i
		Bit.FastArraySetFloat(ColInnerLeft.Values, i, -1)
		Bit.FastArraySetFloat(ColInnerRight.Values, i, -1)
		Bit.FastArraySetFloat(ColOuterLeft.Values, i, -1)
		Bit.FastArraySetFloat(ColOuterRight.Values, i, -1)
	#else
		ColInnerLeft.Values(i) = -1
		ColInnerRight.Values(i) = -1
		ColOuterLeft.Values(i) = -1
		ColOuterRight.Values(i) = -1
	#End If
	Next
	Dim SmallRadius As Int =  iRadius - StrokeWidth
	DrawWuArc(ix, iy, iRadius - 1, CheckBounds, False, ColOuterLeft, ColOuterRight, Brush, StartingAngle, EndAngle)
	DrawWuArc(ix, iy, SmallRadius, CheckBounds, True, ColInnerLeft, ColInnerRight, Brush, StartingAngle, EndAngle)
	If Filled Then
		DrawAntiAliasBorder(ix, iy, 1, Brush, CheckBounds)
	End If
	Dim TempCol As InternalBCColumn
	Dim angles() As Float = Array As Float(StartingAngle, EndAngle)
	For i = 0 To 1
		Dim angle As Float = angles(i)
		Dim Ending As Boolean = i = 1
		Dim lx0, ly0, lx1, ly1 As Float
		lx0 = Round(ix + CosD(angle) * (SmallRadius))
		ly0 = Round(iy + SinD(angle) * (SmallRadius))
		lx1 = Round(ix + CosD(angle) * (iRadius - 1))
		ly1 = Round(iy + SinD(angle) * (iRadius - 1))
		Dim quarter As Int = Floor(angle / 90)
		Select quarter
			Case 0
				If Ending Then
					TempCol = ColInnerRight
				Else
					TempCol = ColOuterRight
				End If
			Case 1
				If Ending Then
					TempCol = ColOuterLeft
				Else
					TempCol = ColInnerLeft
				End If
			Case 2
				If Ending Then
					TempCol = ColInnerLeft
				Else
					TempCol = ColOuterLeft
				End If
			Case 3
				If Ending Then
					TempCol = ColOuterRight
				Else
					TempCol = ColInnerRight
				End If
		End Select
		If ly1 <> ly0 Then
			DrawWuLine(lx0, ly0, lx1, ly1, CheckBounds, TempCol = ColOuterLeft Or TempCol = ColInnerRight, TempCol, TempCol, Brush, True)
		Else
		End If
	Next
	For row = StartY1 To EndY1
		#if B4i
		Dim left1 As Int = Floor(Bit.FastArrayGetFloat(ColOuterLeft.Values, row)) + 1
		Dim right1 As Int = Floor(Bit.FastArrayGetFloat(ColInnerLeft.Values,row)) + 1
		Dim left2 As Int = Floor(Bit.FastArrayGetFloat(ColInnerRight.Values,row)) + 1
		Dim right2 As Int = Floor(Bit.FastArrayGetFloat(ColOuterRight.Values,row)) + 1
		#else
		Dim left1 As Int = Floor(ColOuterLeft.Values(row)) + 1
		Dim right1 As Int = Floor(ColInnerLeft.Values(row)) + 1
		Dim left2 As Int = Floor(ColInnerRight.Values(row)) + 1
		Dim right2 As Int = Floor(ColOuterRight.Values(row)) + 1
		#End If
	
		Dim Inner As Boolean
		If right1 >= left1 And left1 > 0 Then
			Inner = True
			FillHorizontalLine(left1, right1, row, Brush)
		End If
		If right2 >= left2 And left2 > 0 Then
			Inner = True
			FillHorizontalLine(left2, right2, row, Brush)
		End If
		If Inner = False And right2 > left1 And left1 > 0 Then
			FillHorizontalLine(left1, right2, row, Brush)
		End If
	Next
	Return Brush
End Sub

Private Sub DrawWuArc (X0 As Int, Y0 As Int, Radius As Int, CheckBounds As Boolean, Inner As Boolean, _
		ColLeft As InternalBCColumn, ColRight As InternalBCColumn, PaintSource As BCBrush, StartingAngle As Float, EndAngle As Float)
	Dim s As Int = Sin(cPI / 4) * Radius + 0.5
	Dim c As Int = Cos(cPI / 4) * Radius + 0.5
	Dim MinX As Float = Max(0, Min(mWidth - 1 ,X0 - Radius - 1))
	Dim MaxX As Float = Min(mWidth - 1, Max(0, Max(X0, X0 + Radius)))
	Dim r2 As Float = Radius * Radius
	Dim x, y As Float
	Dim ix, iy As Int
	Dim q0ystart, q0yend = -1, q1ystart, q1yend = -1, q2ystart, q2yend = -1, q3ystart, q3yend = -1 As Int
	Dim q0xstart, q0xend = -1, q1xstart, q1xend = -1, q2xstart, q2xend = -1, q3xstart, q3xend = -1 As Int
	'quarter 0
	If StartingAngle < 90 And EndAngle > 0 Then
		q0ystart = SinD(Max(0, StartingAngle)) * Radius + 0.5
		q0yend = SinD(Min(90, EndAngle)) * Radius + 0.5
		q0xend = CosD(Max(0, StartingAngle)) * Radius + 0.5
		q0xstart = CosD(Min(90, EndAngle)) * Radius + 0.5
	End If
	If StartingAngle < 180 And EndAngle > 90 Then
		q1yend = SinD(Max(90, StartingAngle)) * Radius + 0.5
		q1ystart = SinD(Min(180, EndAngle)) * Radius + 0.5
		q1xend = -CosD(Min(180, EndAngle)) * Radius + 0.5
		q1xstart = -CosD(Max(90, StartingAngle)) * Radius + 0.5
	End If
	If StartingAngle < 270 And EndAngle > 180  Then
		q2ystart = -SinD(Max(180, StartingAngle)) * Radius + 0.5
		q2yend =  -SinD(Min(270, EndAngle)) * Radius + 0.5
		q2xstart = -CosD(Min(270, EndAngle)) * Radius + 0.5
		q2xend = -CosD(Max(180, StartingAngle)) * Radius + 0.5
	End If
	If StartingAngle < 360 And EndAngle > 270 Then
		q3yend = -SinD(Max(270, StartingAngle)) * Radius + 0.5
		q3ystart = -SinD(Min(360, EndAngle)) * Radius + 0.5
		q3xstart = CosD(Max(270, StartingAngle)) * Radius + 0.5
		q3xend = CosD(Min(360, EndAngle)) * Radius + 0.5
	End If
	Dim OffsetFix As Int = 1
	For iy = 0 To Radius
		x = Sqrt(r2 - iy * iy)
		ix = x
		If CheckBounds = False Or (Y0 - iy >= 0 And Y0 - iy < mHeight) Then
			'q2
			If (iy >= q2ystart And iy <= q2yend) Then
				#if B4i
				Bit.FastArraySetFloat(ColLeft.Values, Y0 - iy, Max(MinX, X0 - ix - OffsetFix))
				#else
				ColLeft.Values(Y0 - iy) = Max(MinX, X0 - ix - OffsetFix)
				#End If
				
			End If
			'q3
			If (iy >= q3ystart And iy <= q3yend) Then
				#if B4i
				Bit.FastArraySetFloat(ColRight.Values, Y0 - iy,Min(MaxX, X0 + ix))
				#else
				ColRight.Values(Y0 - iy) = Min(MaxX, X0 + ix)
				#end if
			End If
		End If
		If CheckBounds = False Or (Y0 + iy >= 0 And Y0 + iy < mHeight) Then
			'q1
			If (iy >= q1ystart And iy <= q1yend) Then
				#if B4i
				Bit.FastArraySetFloat(ColLeft.Values, Y0 + iy, Max(MinX, X0 - ix - OffsetFix))
				#else
				ColLeft.Values(Y0 + iy) =  Max(MinX, X0 - ix - OffsetFix)
				#end if
			End If
			'q0
			If (iy >= q0ystart And iy <= q0yend) Then
				#if B4i
				Bit.FastArraySetFloat(ColRight.Values, Y0 + iy, Min(MaxX, X0 + ix))
				#else
				ColRight.Values(Y0 + iy) =  Min(MaxX, X0 + ix)
				#end if
			End If
		End If
		If iy <= s Then
			Dim fp As Float = x - ix
			If Inner Then
				If 1 - fp > 0.1 Then
					If (iy >= q3ystart And iy <= q3yend) Then DrawAntiAliasBorder(X0 + ix, Y0 - iy, 1 - fp, PaintSource, CheckBounds)
					If (iy >= q2ystart And iy <= q2yend) Then DrawAntiAliasBorder(X0 - ix, Y0 - iy, 1 - fp, PaintSource, CheckBounds)
					If (iy >= q0ystart And iy <= q0yend) Then DrawAntiAliasBorder(X0 + ix, Y0 + iy, 1 - fp, PaintSource, CheckBounds)
					If (iy >= q1ystart And iy <= q1yend) Then DrawAntiAliasBorder(X0 - ix, Y0 + iy, 1 - fp, PaintSource, CheckBounds)
				End If
			Else if fp > 0.1 Then
				If (iy >= q3ystart And iy <= q3yend) Then DrawAntiAliasBorder(X0 + ix + 1, Y0 - iy, fp, PaintSource, CheckBounds)
				If (iy >= q0ystart And iy <= q0yend) Then DrawAntiAliasBorder(X0 + ix + 1, Y0 + iy, fp, PaintSource, CheckBounds)
				If (iy >= q1ystart And iy <= q1yend) Then DrawAntiAliasBorder(X0 - ix - 1, Y0 + iy, fp, PaintSource, CheckBounds)
				If (iy >= q2ystart And iy <= q2yend) Then DrawAntiAliasBorder(X0 - ix - 1, Y0 - iy, fp, PaintSource, CheckBounds)
			End If
		End If
	Next
	For ix = c To 0 Step - 1
		y = Sqrt(r2 - ix * ix)
		iy = y
		Dim fp As Float = y - iy
		If Inner Or ix = 0 Then
			If 1 - fp > 0.1 Then
				If (ix >= q0xstart And ix <= q0xend) Then DrawAntiAliasBorder(X0 + ix, Y0 + iy, 1 - fp, PaintSource, CheckBounds)
				If (ix >= q3xstart And ix <= q3xend) Then DrawAntiAliasBorder(X0 + ix, Y0 - iy, 1 - fp, PaintSource, CheckBounds)
				If (ix >= q1xstart And ix <= q1xend) Then DrawAntiAliasBorder(X0 - ix, Y0 + iy, 1 - fp, PaintSource, CheckBounds)
				If (ix >= q2xstart And ix <= q2xend) Then DrawAntiAliasBorder(X0 - ix, Y0 - iy, 1 - fp, PaintSource, CheckBounds)
			End If
		Else
			If fp > 0.1 Then
				If (ix >= q0xstart And ix <= q0xend) Then DrawAntiAliasBorder(X0 + ix, Y0 + iy + 1, fp, PaintSource, CheckBounds)
				If (ix >= q1xstart And ix <= q1xend) Then DrawAntiAliasBorder(X0 - ix, Y0 + iy + 1, fp, PaintSource, CheckBounds)
				If (ix >= q3xstart And ix <= q3xend) Then DrawAntiAliasBorder(X0 + ix, Y0 - iy - 1, fp, PaintSource, CheckBounds)
				If (ix >= q2xstart And ix <= q2xend) Then DrawAntiAliasBorder(X0 - ix, Y0 - iy - 1, fp, PaintSource, CheckBounds)
			End If
		End If
	Next
End Sub


Private Sub DrawAntiAliasBorder(x As Int, y As Int, c As Float, PaintSource As BCBrush, CheckBounds As Boolean)
	If c < 0.1 Then Return
	If CheckBounds And (x < 0 Or x >= mWidth Or y < 0 Or y >= mHeight) Then
		Return
	Else
		If PaintSource.IsColorSource Then
			If c >= 0.9 Then
				If PaintSource.BlendBorders Then
					BlendPixel2(PaintSource.ColorPM, x, y)
				Else
					SetPremultipliedColor(x, y, PaintSource.ColorPM)
				End If
			Else
				tempPM2.r = PaintSource.ColorPM.r * c
				tempPM2.g = PaintSource.ColorPM.g * c
				tempPM2.b = PaintSource.ColorPM.b * c
				tempPM2.a = PaintSource.ColorPM.a * c
				If PaintSource.BlendBorders Then
					BlendPixel2(tempPM2, x, y)
				Else
					SetPremultipliedColor(x, y, tempPM2)
				End If
			End If
			
		Else
			Dim SrcX As Int = (x - PaintSource.SrcOffsetX) Mod PaintSource.Source.mWidth
			Dim SrcY As Int = (y - PaintSource.SrcOffsetY) Mod PaintSource.Source.mHeight
			If SrcX < 0 Then SrcX = SrcX + PaintSource.Source.mWidth
			If SrcY < 0 Then SrcY = SrcY + PaintSource.Source.mHeight
			If c >= 0.9 Then
				If PaintSource.BlendBorders Then
					BlendPixel(PaintSource.Source, SrcX, SrcY, x, y)
				Else
					CopyPixel(PaintSource.Source, SrcX, SrcY, x, y)
				End If
			Else
				PaintSource.Source.GetPremultipliedColor(SrcX, SrcY, tempPM2)
				tempPM2.r = Bit.And(0xff, tempPM2.r) * c
				tempPM2.g =  Bit.And(0xff, tempPM2.g) * c
				tempPM2.b =  Bit.And(0xff, tempPM2.b) * c
				tempPM2.a =  Bit.And(0xff, tempPM2.a) * c
				If PaintSource.BlendBorders Then
					BlendPixel2(tempPM2, x, y)
				Else
					SetPremultipliedColor(x, y, tempPM2)
				End If
			End If
		End If
	End If
End Sub

'Draws a rectangle. Returns the color brush.
Public Sub DrawRect (Rect As B4XRect, Color As Int, Filled As Boolean, StrokeWidth As Int) As BCBrush
	Return DrawRect2(Rect, CreateBrushFromColor(Color), Filled, StrokeWidth)
End Sub

'Draws a rectangle with round corners. Returns the color brush.
'Note that CornersRadius is expected to be larger than StrokeWidth for unfilled shapes.
Public Sub DrawRectRounded (Rect As B4XRect, Color As Int, Filled As Boolean, StrokeWidth As Int, CornersRadius As Int) As BCBrush
	Return DrawRectRounded2(Rect, CreateBrushFromColor(Color), Filled, StrokeWidth, CornersRadius)
End Sub

'Draws a rectangle with round corners.
Public Sub DrawRectRounded2 (Rect As B4XRect, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int, CornersRadius As Int) As BCBrush
	If CornersRadius < 1 Then
		Return DrawRect2(Rect, Brush, Filled, StrokeWidth)
	End If
	Dim Width As Int = Round(Rect.Width)
	Dim Height As Int = Round(Rect.Height)
	CornersRadius = Min(CornersRadius, Min(Width, Height) / 2)
	Dim cx As Int = Rect.CenterX
	Dim cy As Int = Rect.CenterY
	Dim ExtendX1 As Int = Width / 2 - CornersRadius
	Dim ExtendX2 As Int = Width - 2 * CornersRadius - ExtendX1
	Dim ExtendY1 As Int = Height / 2 - CornersRadius
	Dim ExtendY2 As Int = Height - 2 * CornersRadius - ExtendY1
	Return DrawCircleImpl(cx, cy, CornersRadius, Brush, Filled, StrokeWidth, ExtendX1 + 1, ExtendX2, ExtendY1 + 1, ExtendY2)
End Sub

'Draws a rectangle.
Public Sub DrawRect2 (Rect As B4XRect, Brush As BCBrush, Filled As Boolean, StrokeWidth As Int) As BCBrush
	If Rect.Left >= mWidth Or Rect.Right < 0 Or Rect.Top >= mHeight Or Rect.Bottom < 0 Then Return Brush
	If Filled Then
		Dim StartY As Int = Max(0, Rect.Top)
		Dim EndY As Int = Min(mHeight - 1, Rect.Bottom - 1)
		Dim StartX As Int = Max(0, Rect.Left)
		Dim EndX As Int = Min(mWidth - 1, Rect.Right - 1)
		Dim length As Int =(EndX - StartX + 1) * 4
		If Brush.IsColorSource Then
			For y = StartY * mWidth * 4 To EndY * mWidth * 4 Step mWidth * 4
				Bit.ArrayCopy(Brush.Source.mBuffer, 0, mBuffer, y + StartX * 4, length)
			Next
		Else
			For y = StartY To EndY
				FillHorizontalLine(StartX, EndX, y, Brush)
			Next
		End If
	Else
		Dim Top As Int = Rect.Top
		Dim Left As Int = Rect.Left
		Dim Right As Int = Rect.Right
		Dim Bottom As Int = Rect.Bottom
		Dim lfixed As Int = Max(0, Left)
		Dim rfixed As Int = Min(mWidth, Right)
		For y = Max(0, Top) To Min(mHeight, Top + StrokeWidth) - 1
			FillHorizontalLine(lfixed, rfixed, y, Brush)
		Next
		For y = Max(0, Bottom - StrokeWidth) To Min(mHeight, Bottom) - 1
			FillHorizontalLine(lfixed, rfixed, y, Brush)
		Next
		Dim CheckBounds As Boolean = Left < 0 Or Top < 0 Or Bottom > mHeight Or Right > mWidth
		If CheckBounds = False Then
			For y = Top + StrokeWidth To Bottom - StrokeWidth - 1
				FillHorizontalLine(Left, Left + StrokeWidth, y, Brush)
				FillHorizontalLine(Right - StrokeWidth, Right, y, Brush)
			Next
		Else
			Dim lengthleft As Int = Min(StrokeWidth, Left + StrokeWidth)
			Dim lengthright As Int = Min(StrokeWidth, mWidth + StrokeWidth - Right)
			For y = Max(0, Top + StrokeWidth) To Min(Bottom - StrokeWidth, mHeight) - 1
				If lengthleft > 0 Then
					FillHorizontalLine(lfixed, lfixed + lengthleft, y, Brush)
				End If
				If lengthright > 0 Then
					FillHorizontalLine(rfixed - lengthright, rfixed, y, Brush)
				End If
			Next
		End If
	End If
	Return Brush
End Sub

'DEPRECATED: use DrawRect instead.
Public Sub FillRect (Color As Int, Rect As B4XRect)
	DrawRect(Rect, Color, True, 0)
End Sub

'Replaces all semi-transparent pixels in the Rect with NewColor.
'This can be useful to remove antialiasing effects.
Public Sub ReplaceSemiTransparentPixels (NewColor As Int, Rect As B4XRect)
	Dim StartX As Int = Max(0, Rect.Left)
	Dim EndX As Int = Min(mWidth - 1, Rect.Right - 1)
	Dim StartY As Int = Max(0, Rect.Top)
	Dim EndY As Int = Min(mHeight - 1, Rect.Bottom - 1)
	If EndX < StartX Or EndY < StartY Then Return
	ColorToARGB(NewColor, tempARGB)
	ARGBToPremultipliedColor(tempARGB, tempPM)
	For y = StartY To EndY
		For x = StartX To EndX 
			Dim cp As Int = x * 4 + y * mWidth * 4
			Dim b As Byte = mBuffer(cp + ai)
			If b <> UnsignedFF And b <> 0 Then
				SetPremultipliedColor(x, y, tempPM)
			End If
		Next
	Next
End Sub

'Draws a bitmap to the buffer.
'SkipBlending - Whether non-opaque pixels in the source bitmap should blend with the background.
Public Sub DrawBitmap (Bmp As B4XBitmap, TargetRect1 As B4XRect, SkipBlending As Boolean)
	If Bmp.Width <> TargetRect1.Width Or Bmp.Height <> TargetRect1.Height Then
		Bmp = Bmp.Resize(TargetRect1.Width, TargetRect1.Height, False)
	End If
	Dim Src As BitmapCreator
	Src.Initialize(Bmp.Width, Bmp.Height)
	Src.CopyPixelsFromBitmap(Bmp)
	Dim SrcRect As B4XRect
	SrcRect.Initialize(0, 0, Src.mWidth, Src.mHeight)
	DrawBitmapCreator(Src, SrcRect, TargetRect1.Left, TargetRect1.Top, SkipBlending)
End Sub

'Creates a DrawTask object.
Public Sub CreateDrawTask (Source As Object, SrcRect As B4XRect, TargetX As Int, TargetY As Int, SkipBlending As Boolean) As DrawTask
	Dim dt As DrawTask
	dt.Source = Source
	dt.SrcRect = SrcRect
	dt.TargetX = TargetX
	dt.TargetY = TargetY
	dt.SkipBlending = SkipBlending
	dt.SrcScaleX = 1
	dt.SrcScaleY = 1
	dt.TargetBC = Null
	Return dt
End Sub
'Draws the image stored in the Source BitmapCreator to this BitmapCreator.
'Source - Source BitmapCreator
'SrcRect - Defines the region in the Source BC that will be copied.
'TargetX / TargetY - Top left point in the destination BC.
'SkipBlending - Whether non-opaque pixels in the source bitmap should blend with the background. 
Public Sub DrawBitmapCreator (Source As BitmapCreator, SrcRect As B4XRect, TargetX As Int, TargetY As Int, SkipBlending As Boolean)
	#if Stats
	Dim Clock As Long = DateTime.Now
	#End If
	If TargetY >= mHeight Or TargetX >= mWidth Then Return
	If TargetX + SrcRect.Width < 0 Or TargetY + SrcRect.Height < 0 Then Return
	Dim SrcTop As Int = SrcRect.Top
	Dim SrcLeft As Int = SrcRect.Left
	If TargetX < 0 Then
		SrcLeft = SrcLeft - TargetX
		TargetX = 0
	End If
	If TargetY < 0 Then
		SrcTop = SrcTop - TargetY
		TargetY = 0
	End If
	Dim SrcWidth As Int = SrcRect.Right - SrcLeft
	Dim SrcHeight As Int = SrcRect.Bottom - SrcTop
	TargetY = Max(0, TargetY)
	Dim DeltaX As Int = Min(mWidth - 1 - TargetX, Min(SrcWidth - 1, Source.mWidth - 1 - SrcLeft))
	Dim DeltaY As Int = Min(mHeight - 1 - TargetY, Min(SrcHeight - 1, Source.mHeight - 1 - SrcTop))
	
	If SkipBlending Then
		If TargetX = 0 And TargetY = 0 And SrcLeft = 0 And SrcTop = 0 And SrcWidth = Source.mWidth And SrcWidth = mWidth And _
			SrcHeight = Source.mHeight And SrcHeight = mHeight Then
			Bit.ArrayCopy(Source.mBuffer, 0, mBuffer, 0, mBuffer.Length)
		Else
			'Dim cp As Int = x * 4 + y * mWidth * 4
			For y = TargetY To TargetY + DeltaY
				Bit.ArrayCopy(Source.mBuffer, SrcLeft * 4 + (y - TargetY + SrcTop) * 4 * Source.mWidth, mBuffer, _
				TargetX * 4 + y * 4 * mWidth, (DeltaX + 1) * 4)
			Next
		End If
		
	Else
		For x = TargetX To TargetX + DeltaX
			For y = TargetY To TargetY + DeltaY
				#if B4i
				Dim cp1 As Int = (x - TargetX + SrcLeft) * 4 + (y - TargetY + SrcTop) * Source.mWidth * 4
				Dim cp2 As Int = x * 4 + y * mWidth * 4
				Dim a1 As Byte = Bit.FastArrayGetByte(Source.mBuffer, cp1 + ai)
				Dim r1 As Byte = Bit.FastArrayGetByte(Source.mBuffer, cp1 + ri)
				Dim g1 As Byte = Bit.FastArrayGetByte(Source.mBuffer, cp1 + gi)
				Dim b1 As Byte = Bit.FastArrayGetByte(Source.mBuffer, cp1 + bi)
				
				If a1 <> UnsignedFF Then
					If a1 = 0 Then Continue
					Dim a2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + ai)
					Dim r2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + ri)
					Dim g2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + gi)
					Dim b2 As Byte = Bit.FastArrayGetByte(mBuffer, cp2 + bi)
					Dim SrcAF As Float = 1 - (a1 / 255)
					r1 =  r1 + SrcAF *  r2
					g1 =  g1 + SrcAF *  g2
					b1 =  b1 + SrcAF *  b2
					a1 =  a1 + SrcAF *  a2
				End If
				Bit.FastArraySetByte(mBuffer, cp2 + ri, r1)
				Bit.FastArraySetByte(mBuffer, cp2 + gi, g1)
				Bit.FastArraySetByte(mBuffer, cp2 + bi, b1)
				Bit.FastArraySetByte(mBuffer, cp2 + ai, a1)
				#else
				BlendPixel(Source, x - TargetX + SrcLeft, y - TargetY + SrcTop, x, y)
				
				#End If
			Next
		Next
	End If
	#if Stats
	Log($"DrawBitmapCreator: ${DateTime.Now - Clock} ms"$)
	#End If
End Sub

Public Sub FlipCompressedBitmap (Source As CompressedBC, Horizontal As Boolean, Vertical As Boolean) As CompressedBC
	If Horizontal = False And Vertical = False Then Return Source
	Dim NewCBC As CompressedBC
	NewCBC.Initialize
	NewCBC.Rows.Initialize
	NewCBC.mWidth = Source.mWidth
	NewCBC.mHeight = Source.mHeight
	NewCBC.TargetRect = Source.TargetRect
	NewCBC.Cache = Source.Cache
	If Horizontal = False Then
		NewCBC.mBuffer = Source.mBuffer
		For y = Source.Rows.Size - 1 To 0 Step -1
			NewCBC.Rows.Add(Source.Rows.Get(y))
		Next
	Else
		Dim NewBuffer(Source.mBuffer.Length) As Byte
		NewCBC.mBuffer = NewBuffer
		Dim SourceLast As Int = Source.mBuffer.Length - 4
		For i = 0 To NewBuffer.Length - 3 Step 4
			#if B4i
			Bit.FastArraySetByte(NewBuffer, i, Bit.FastArrayGetByte(Source.mBuffer, SourceLast - i))
			Bit.FastArraySetByte(NewBuffer, i + 1, Bit.FastArrayGetByte(Source.mBuffer, SourceLast - i + 1))
			Bit.FastArraySetByte(NewBuffer, i + 2, Bit.FastArrayGetByte(Source.mBuffer, SourceLast - i + 2))
			Bit.FastArraySetByte(NewBuffer, i + 3, Bit.FastArrayGetByte(Source.mBuffer, SourceLast - i + 3))
			#else
			NewBuffer(i) = Source.mBuffer(SourceLast - i)
			NewBuffer(i + 1) = Source.mBuffer(SourceLast - i + 1)
			NewBuffer(i + 2) = Source.mBuffer(SourceLast - i + 2)
			NewBuffer(i + 3) = Source.mBuffer(SourceLast - i + 3)
			#End If
			
		Next
		
		Dim index As Int
		For y = Source.Rows.Size - 1 To 0 Step -1
			Dim RowSize As Int
			#if B4i
			Dim Row() As Byte = Source.Rows.Get(y)
			RowSize = Row.Length / 4
			#else
			Dim row As List = Source.Rows.Get(y)
			RowSize = row.Size
			#End If
			#if B4i
			Dim NewRow(Row.Length) As Byte
			Bit.FastArraySetInt(NewRow, 0, index)
			#else
			Dim NewRow As List
			NewRow.Initialize
			NewRow.Add(index)
			#End If
			For i = RowSize - 2 To 1 Step -2
				#if B4i
				Dim state As Byte = Bit.FastArrayGetInt(Row, i)
				Dim count As Int = Bit.FastArrayGetInt(Row, i + 1)
				Bit.FastArraySetInt(NewRow, RowSize - 2 - i + 1, state)
				Bit.FastArraySetInt(NewRow, RowSize - 2 - i + 2, count)
				#else
				Dim state As Byte = row.Get(i)
				Dim count As Int = row.Get(i + 1)
				NewRow.Add(state)
				NewRow.Add(count)
				#End If
				If state = CACHE_SOLID Then
					index = index + count
				End If
			Next
			If Vertical Then
				NewCBC.Rows.Add(NewRow)
			Else
				NewCBC.Rows.InsertAt(0, NewRow)
			End If
		Next
	End If
	Return NewCBC
End Sub


'Private Sub PrintBCRow(index As Int)
'	Dim sb As StringBuilder
'	sb.Initialize
'	For x = 0 To mWidth - 1
'		'If x Mod 10 = 0 Then sb.Append(CRLF)
'		sb.Append(PrintColor(mBuffer, mWidth * index * 4 + x * 4)).Append(",")
'	Next
'	Log("******************* BC: " & index)
'	Log(sb)
'End Sub
'
'Private Sub PrintCBCRow(cbc As CompressedBC, y As Int)
'	Dim row As List = cbc.Rows.Get(y)
'	Dim sb As StringBuilder
'	sb.Initialize
'	Dim index As Int = row.Get(0)
'	Dim bc As ByteConverter
'	For i = 1 To row.Size - 1 Step 2
'		Dim state As Byte = row.Get(i)
'		Dim count As Int = row.Get(i + 1)
'		If state = CACHE_TRANSPARENT Then
'			For x = 0 To count - 1
'				sb.Append(bc.HexFromBytes(Array As Byte(0, 0, 0, 0))).Append(",")
'			Next
'		Else If state = CACHE_SOLID Then
'			For x = 0 To count - 1
'				sb.Append(PrintColor(cbc.mBuffer, (index + x) * 4)).Append(",")
'			Next
'			index = index + count
'		Else If state > CACHE_SOLID Then
'			For x = 0 To state - 1
'				sb.Append(bc.HexFromBytes(Array As Byte(0xbb, 0xbb, 0xbb, 0xbb))).Append(",")
'			Next
'		End If
'	Next
'	Log("******************* cbc: " & y)
'	Log(sb)
'End Sub
'
'Private Sub PrintColor(buffer() As Byte, index As Int) As String
'	Dim b(4) As Byte
'	b(0) = buffer(index + ai)
'	b(1) = buffer(index + ri)
'	b(2) = buffer(index + gi)
'	b(3) = buffer(index + bi)
'	Dim bc As ByteConverter
'	Return bc.HexFromBytes(b)
'End Sub

'Draws a CompressedBC object created with BitmapCreator.ExtractCompressBC.	
Public Sub DrawCompressedBitmap (Source As CompressedBC, SrcRect As B4XRect, TargetX As Int, TargetY As Int)
	#if Stats
	Dim Clock As Long = DateTime.Now
	#End If
	If TargetY >= mHeight Or TargetX >= mWidth Then Return
	If TargetX + SrcRect.Width < 0 Or TargetY + SrcRect.Height < 0 Then Return
	Dim SrcTop As Int = SrcRect.Top
	Dim SrcLeft As Int = SrcRect.Left
	If TargetX < 0 Then
		SrcLeft = SrcLeft - TargetX
		TargetX = 0
	End If
	If TargetY < 0 Then
		SrcTop = SrcTop - TargetY
		TargetY = 0
	End If
	Dim SrcWidth As Int = SrcRect.Right - SrcLeft
	Dim SrcHeight As Int = SrcRect.Bottom - SrcTop
	TargetY = Max(0, TargetY)
	Dim DeltaX As Int = Min(mWidth - 1 - TargetX, Min(SrcWidth - 1, Source.mWidth - 1 - SrcLeft))
	Dim DeltaY As Int = Min(mHeight - 1 - TargetY, Min(SrcHeight - 1, Source.mHeight - 1 - SrcTop))
	For y = TargetY To TargetY + DeltaY
		Dim RowSize As Int
		#if B4i
		Dim Row() As Byte = Source.Rows.Get(y - TargetY + SrcTop)
		RowSize = Row.Length / 4
		#else
		Dim row As List = Source.Rows.Get(y - TargetY + SrcTop)
		RowSize = row.Size
		#End If
		Dim x As Int = 0
		Dim FixedX, FixedCount As Int
		
		#if B4i
		Dim CBCDataOffset As Int = Bit.FastArrayGetInt(Row, 0)
		#else
		Dim CBCDataOffset As Int = row.Get(0)
		#End If
		For i = 1 To RowSize - 1 Step 2
			#if B4i
			Dim state As Byte = Bit.FastArrayGetInt(Row, i)
			Dim count As Int = Bit.FastArrayGetInt(Row, i + 1)
			#else
			Dim state As Byte = row.Get(i)
			Dim count As Int = row.Get(i + 1)
			#End If
			Dim cache_position As Int
			If state > CACHE_SOLID Then
				cache_position = count
				count = state
			End If
			
			If SrcLeft < x Then
				FixedX = x
				FixedCount = count
			Else
				If SrcLeft >= x + count Then
					x = x + count
					If state = CACHE_SOLID Then CBCDataOffset = CBCDataOffset + count
					If x > DeltaX + SrcLeft Then Exit
					Continue
				Else
					FixedX = SrcLeft
					FixedCount = count - (SrcLeft - x)
					If state  = CACHE_SOLID Then CBCDataOffset = CBCDataOffset + SrcLeft - x
				End If
			End If
			
			
			If state = CACHE_TRANSPARENT Then
			
			Else If state = CACHE_SOLID Then
				Bit.ArrayCopy(Source.mBuffer, CBCDataOffset * 4, mBuffer, _
						(TargetX + FixedX - SrcLeft) * 4 + y * 4 * mWidth, Min(FixedCount, (DeltaX + 1 - (x - SrcLeft))) * 4)
				CBCDataOffset = CBCDataOffset + FixedCount
			Else 'same color
				'cache_position
				Bit.ArrayCopy(Source.Cache.mBuffer, cache_position , mBuffer, _
						(TargetX + FixedX - SrcLeft) * 4 + y * 4 * mWidth, Min(FixedCount, (DeltaX + 1 - (x - SrcLeft))) * 4)
			End If
				
			x = x + count
			If x > DeltaX + SrcLeft Then Exit
		Next
	Next
	#if Stats
	Log($"DrawCompressedBitmap: ${DateTime.Now - Clock} ms"$)
	#End If
End Sub

'Rotates with antialiasing.
Public Sub DrawRotatedCBC (cbc As CompressedBC, Degrees As Float, Width As Int, Height As Int, AABuffer As InternalAntiAliasingBuffer)
	DrawRotatedCBC2(cbc, Degrees, Width, Height, AABuffer, 0, 0)
End Sub

Private Sub DrawRotatedCBC2 (cbc As CompressedBC, Degrees As Float, Width As Int, Height As Int, AABuffer As InternalAntiAliasingBuffer, Left As Int, Top As Int)
	Dim srca As ARGBColor
	Dim cosl As Float = CosD(Degrees)
	Dim sinl As Float = SinD(Degrees)
	Dim srccx As Float = cbc.mWidth / 2
	Dim srccy As Float = cbc.mHeight / 2
	Dim targetcx As Float = Width / 2
	Dim targetcy As Float = Height / 2
	Dim TargetX, TargetY As Int
	#if B4i
	Dim dx(4 * 4), dy(4 * 4) As Byte
	Bit.FastArraySetFloat(dx, 1, 0.5 * cosl)
	Bit.FastArraySetFloat(dy, 1,  0.5 * sinl)
	Bit.FastArraySetFloat(dx, 2, -0.5 * sinl)
	Bit.FastArraySetFloat(dy, 2,  0.5 * cosl)
	Bit.FastArraySetFloat(dx, 3, cosl / 2 - sinl / 2)
	Bit.FastArraySetFloat(dy, 3,  sinl / 2 + cosl / 2)
	Dim PixelDeltaX As Float = 2 * Bit.FastArrayGetFloat(dx, 1)
	Dim PixelDeltaY As Float = 2 * Bit.FastArrayGetFloat(dy, 1)
	Dim IntsArray() As Byte = AABuffer.IntsArray
	#else
	Dim IntsArray() As Int = AABuffer.IntsArray
	Dim dx(4), dy(4) As Float
	dx(1) = 0.5 * cosl
	dy(1) = 0.5 * sinl
	dx(2) = -0.5 * sinl
	dy(2) = 0.5 * cosl
	dx(3) = cosl / 2 - sinl / 2
	dy(3) = sinl / 2 + cosl / 2
	Dim PixelDeltaX As Float = 2 * dx(1)
	Dim PixelDeltaY As Float = 2 * dy(1)
	#End If
	Dim RowLen As Int = Width * 5
	Dim index As Int
	'reset the counts
	For yy = 0 To Height - 1
		Dim index As Int = yy * RowLen
		For xx = 0 To Width - 1
			#if B4i
			Bit.FastArraySetInt(IntsArray, index + 4, 0)
			#else
			IntsArray(index + 4) = 0
			#End If
			index = index + 5
		Next
	Next
	#if B4i
	Dim StubRow(3 * 4) As Byte
	Bit.FastArraySetInt(StubRow, 2, cbc.mWidth)
	#Else
	Dim StubRow As List = Array(0, 0, cbc.mWidth)
	#End If
	Dim ystart As Float = (0 - srccx) * sinl + (0 - srccy) * cosl + targetcy
	For srcy = -1 To cbc.mHeight
		Dim y As Float = ystart
		Dim x As Float = (0 - srccx) * cosl - (srcy - srccy) * sinl + targetcx
		If srcy = -1 Or srcy = cbc.mHeight Then
			#if B4i
			Dim Row() As Byte = StubRow
			Dim RowSize As Int = 3
			#else
			Dim row As List = StubRow
			Dim RowSize As Int = row.Size
			#End If
		
		Else
			#if B4i
			Dim Row() As Byte = cbc.Rows.Get(srcy)
			Dim RowSize As Int = Row.Length / 4
			#else
			Dim row As List = cbc.Rows.Get(srcy)
			Dim RowSize As Int = row.size
			#End If
		End If
		
		#if B4i
		Dim CBCDataOffset As Int = Bit.FastArrayGetInt(Row, 0) * 4
		#else
		Dim CBCDataOffset As Int = row.Get(0) * 4
		#End If
		Dim StartI = 1, EndI = RowSize - 1 As Int
		#if B4i
		If Bit.FastArrayGetInt(Row, 0) <> CACHE_TRANSPARENT Then StartI = -1
		If Bit.FastArrayGetInt(Row, RowSize - 2) <> CACHE_TRANSPARENT Then EndI = RowSize + 1
		#else
		If row.Get(0) <> CACHE_TRANSPARENT Then StartI = -1
		If row.Get(row.Size - 2) <> CACHE_TRANSPARENT Then EndI = RowSize + 1
		#End If
		For i = StartI To EndI Step 2
			#if B4i
			If i = -1 Or i = RowSize Then
				Dim state As Byte = CACHE_TRANSPARENT
				Dim count As Int = 1
			Else
				Dim state As Byte = Bit.FastArrayGetInt(Row, i)
				Dim count As Int = Bit.FastArrayGetInt(Row, i + 1)
			End If
			
			#else
			If i = -1 Or i = RowSize Then
				Dim state As Byte = CACHE_TRANSPARENT
				Dim Count As Int = 1
			Else
				Dim state As Byte = row.Get(i)
				Dim Count As Int = row.Get(i + 1)
			End If
			#End If
			
			If state > CACHE_SOLID Then
				Dim cache_position As Int = Count
				Count = state
				#if B4i
				srca.a = Bit.FastArrayGetByte(cbc.Cache.mBuffer, cache_position + ai)
				Dim af As Float = srca.a / 255
				srca.r = Bit.FastArrayGetByte(cbc.Cache.mBuffer, cache_position + ri) / af
				srca.g = Bit.FastArrayGetByte(cbc.Cache.mBuffer, cache_position + gi) / af
				srca.b = Bit.FastArrayGetByte(cbc.Cache.mBuffer, cache_position + bi) / af
				#Else
				srca.a = Bit.And(0xff, cbc.Cache.mBuffer(cache_position + ai))
				Dim af As Float = srca.a / 255
				srca.r = Bit.And(0xff, cbc.Cache.mBuffer(cache_position + ri)) / af
				srca.g = Bit.And(0xff, cbc.Cache.mBuffer(cache_position + gi)) / af
				srca.b = Bit.And(0xff,cbc.Cache.mBuffer(cache_position + bi)) / af
				#end if
			Else If state = CACHE_TRANSPARENT Then
				srca.a = 0
				srca.r = 0
				srca.g = 0
				srca.b = 0
			End If
			For c = 0 To Count - 1
				If state = CACHE_SOLID Then
					#if B4i
					srca.a = Bit.FastArrayGetByte(cbc.mBuffer, CBCDataOffset + ai)
					Dim af As Float = srca.a / 255
					srca.r = Bit.FastArrayGetByte(cbc.mBuffer, CBCDataOffset + ri) / af
					srca.g = Bit.FastArrayGetByte(cbc.mBuffer, CBCDataOffset + gi) / af
					srca.b = Bit.FastArrayGetByte(cbc.mBuffer, CBCDataOffset + bi) / af
					#Else
					srca.a = Bit.And(0xff, cbc.mBuffer(CBCDataOffset + ai))
					Dim af As Float = srca.a / 255
					srca.r = Bit.And(0xff, cbc.mBuffer(CBCDataOffset + ri)) / af
					srca.g = Bit.And(0xff, cbc.mBuffer(CBCDataOffset + gi)) / af
					srca.b = Bit.And(0xff,cbc.mBuffer(CBCDataOffset + bi)) / af
					#end if
					CBCDataOffset = CBCDataOffset + 4
				End If
				For ii = 0 To 3
					#if B4i
					TargetX = x + Bit.FastArrayGetFloat(dx, ii) + 0.5
					TargetY = y + Bit.FastArrayGetFloat(dy, ii) + 0.5
					#else
					TargetX = x + dx(ii) + 0.5
					TargetY = y + dy(ii) + 0.5
					#End If
					If TargetX < 0 Or TargetY < 0 Or TargetX >= Width Or TargetY >= Height Then
						Continue
					End If
					Dim index As Int = TargetX * 5 + TargetY * RowLen
					Dim CountInc As Int
					#if B4i
					Dim RawCount As Int = Bit.FastArrayGetInt(IntsArray, index + 4)
					Dim PointCount As Int = Bit.And(0xff, RawCount)
					If PointCount = 0 Then
						Bit.FastArraySetInt(IntsArray, index, srca.a)
						Bit.FastArraySetInt(IntsArray, index + 1, srca.r)
						Bit.FastArraySetInt(IntsArray, index + 2, srca.g)
						Bit.FastArraySetInt(IntsArray, index + 3, srca.b)
						If srca.a = 0 Then CountInc = 0x101 Else CountInc = 1
					Else If srca.a > 0 Then
						Bit.FastArraySetInt(IntsArray, index, Bit.FastArrayGetInt(IntsArray, index) + srca.a)
						Bit.FastArraySetInt(IntsArray, index + 1, Bit.FastArrayGetInt(IntsArray, index + 1) + srca.r)
						Bit.FastArraySetInt(IntsArray, index + 2, Bit.FastArrayGetInt(IntsArray, index + 2) + srca.g)
						Bit.FastArraySetInt(IntsArray, index + 3, Bit.FastArrayGetInt(IntsArray, index + 3) + srca.b)
						CountInc = 1
					Else
						CountInc = 0x101
					End If
					Bit.FastArraySetInt(IntsArray, index + 4, RawCount + CountInc)
					#else
					Dim RawCount As Int = IntsArray(index + 4)
					Dim PointCount As Int = Bit.And(0xff, RawCount)
					If PointCount = 0 Then
						IntsArray(index) = srca.a
						IntsArray(index + 1) = srca.r
						IntsArray(index + 2) = srca.g
						IntsArray(index + 3) = srca.b
						If srca.a = 0 Then CountInc = 0x101 Else CountInc = 1
					Else If srca.a > 0 Then
						IntsArray(index) = IntsArray(index) + srca.a
						IntsArray(index + 1) = IntsArray(index + 1) + srca.r
						IntsArray(index + 2) = IntsArray(index + 2) + srca.g
						IntsArray(index + 3) = IntsArray(index + 3) + srca.b
						CountInc = 1
					Else
						CountInc = 0x101
					End If
					IntsArray(index + 4) = RawCount + CountInc
					#End If
					
				Next
				x = x + PixelDeltaX
				y = y + PixelDeltaY
			Next
		Next
		#if B4i
		ystart = ystart + Bit.FastArrayGetFloat(dy, 2) * 2
		#else
		ystart = ystart + dy(2) * 2
		#End If
	Next
	
	Dim a As ARGBColor
	For y = 0 To Height - 1
		Dim index As Int = y * RowLen
		#if B4i
		Dim cp As Int = (y + Top) * mWidth * 4 + Left * 4
		#End If
		For x = 0 To Width - 1
			#if B4i
			If Bit.FastArrayGetInt(IntsArray, index) > 0 Then
				Dim RawCount As Int = Bit.FastArrayGetInt(IntsArray, index + 4)
				Dim count As Int = Bit.And(0xff, RawCount)
				If count > 0 Then
					a.a = Bit.FastArrayGetInt(IntsArray, index) / count
					Dim af As Float = a.a / 255
					If RawCount > 0xff Then
						count = count - Bit.ShiftRight(Bit.And(0xff00, RawCount), 8)
					End If
					a.r = Bit.FastArrayGetInt(IntsArray, index + 1) / count * af
					a.g = Bit.FastArrayGetInt(IntsArray, index + 2) / count * af
					a.b = Bit.FastArrayGetInt(IntsArray, index + 3) / count * af
					Bit.FastArraySetByte(mBuffer, cp + ri, a.r)
					Bit.FastArraySetByte(mBuffer, cp + gi, a.g)
					Bit.FastArraySetByte(mBuffer, cp + bi, a.b)
					Bit.FastArraySetByte(mBuffer, cp + ai, a.a)
				End If
			End If
			cp = cp + 4
			#else
			If IntsArray(index) > 0 Then
				Dim RawCount As Int = IntsArray(index + 4)
				Dim Count As Int = Bit.And(0xff, RawCount)
				If Count > 0 Then
					a.a = IntsArray(index) / Count
					If RawCount > 0xff Then 
						Count = Count - Bit.ShiftRight(Bit.And(0xff00, RawCount), 8)
					End If
					a.r = IntsArray(index + 1) / Count
					a.g = IntsArray(index + 2) / Count
					a.b = IntsArray(index + 3) / Count
					SetARGB(x + Left, y + Top, a)
				End If
			End If
			#End If
			
			index = index + 5
		Next
	Next
End Sub

Public Sub ExtractCompressedBC (Rect As B4XRect, Cache As InternalCompressedBCCache) As CompressedBC
	Dim cbc As CompressedBC
	cbc.Initialize
	cbc.Rows.Initialize
	cbc.mWidth = Rect.Width
	cbc.mHeight = Rect.Height
	cbc.TargetRect.Initialize(0, 0, Rect.Width, Rect.Height)
	cbc.Cache = Cache
	Dim Left = Rect.Left, Right = Rect.Right As Int
	Dim Top = Rect.Top, Bottom = Rect.Bottom As Int
	Dim Index As Int
	Dim LastA As Int, LastR, LastG, LastB As Byte
	Dim CheckForSameColor As Boolean = Cache.ColorsMap.Size < MAX_SAME_COLOR_SIZE
	Dim ColorKey As Int = 0
	Dim ColorPosition As Int = -1
	Dim SameColorCount As Int
	#if B4i
	Dim RowIndex As Int
	Dim Row(2000) As Byte
	#End If
	For y = Top To Bottom - 1
		#if B4i
		RowIndex = 0
		Bit.FastArraySetInt(Row, RowIndex, Index) : RowIndex = RowIndex + 1
		#else
		Dim Row As List
		Row.Initialize
		Row.Add(Index)
		#End If
		
		SameColorCount = 0
		LastA = -1000
		LastR = 0
		LastG = 0
		LastB = 0
		Dim EndOfLastSection As Int = Left - 1
		Dim CurrentState As Int
		For x = Left To Right - 1
			Dim offset As Int = x * 4 + y * mWidth * 4
			Dim NewState As Byte
			#if B4I
			Dim a As Int = Bit.FastArrayGetByte(mBuffer, offset + ai)
			#else
			Dim a As Int = mBuffer(offset + ai)
			#End If
			
			If a = UnsignedFF Then
				NewState = CACHE_SOLID
			Else If a = 0 Then
				NewState = CACHE_TRANSPARENT
			Else
				If Bit.And(0xff, a) > AlphaThresholdForCBCExtraction Then
					NewState = CACHE_SOLID
				Else
					NewState = CACHE_TRANSPARENT
				End If
			End If
			If x = Left Then
				CurrentState = NewState
			End If
			If NewState = CACHE_SOLID And CheckForSameColor Then
				#if B4i
				Dim r As Byte = Bit.FastArrayGetByte(mBuffer, offset + ri)
				Dim g As Byte = Bit.FastArrayGetByte(mBuffer, offset + gi)
				Dim b As Byte = Bit.FastArrayGetByte(mBuffer, offset + bi)
				#else
				Dim r As Byte = mBuffer(offset + ri)
				Dim g As Byte = mBuffer(offset + gi)
				Dim b As Byte = mBuffer(offset + bi)
				#End If
				
				If a = LastA And r = LastR And g = LastG And b = LastB Then
					SameColorCount = SameColorCount + 1
				Else
					LastA = a : LastR = r : LastG = g : LastB = b
					SameColorCount = 1
				End If
				If SameColorCount = SAME_COLOR_LENGTH_FOR_CACHE  Then
					If x - EndOfLastSection > SAME_COLOR_LENGTH_FOR_CACHE Then
						Dim PrevCount As Int = x - EndOfLastSection - SAME_COLOR_LENGTH_FOR_CACHE
						#if B4i
						Bit.FastArraySetInt(Row, RowIndex, CACHE_SOLID) : RowIndex = RowIndex + 1
						Bit.FastArraySetInt(Row, RowIndex, PrevCount) : RowIndex = RowIndex + 1
						#else
						Row.Add(CACHE_SOLID)
						Row.Add(PrevCount)
						#End If
						Index = Index + PrevCount
					End If
					#if B4i
					Bit.FastArraySetInt(Row, RowIndex, SAME_COLOR_LENGTH_FOR_CACHE) : RowIndex = RowIndex + 1
					#else
					Row.Add(SAME_COLOR_LENGTH_FOR_CACHE)
					#End If
					Dim key As Int = LastA + Bit.ShiftLeft(Bit.And(0xff, LastR), 16) + Bit.ShiftLeft(Bit.And(0xff, LastG), 8) + Bit.And(0xff, LastB)
					If key <> ColorKey Then
						ColorPosition = Cache.ColorsMap.GetDefault(key, -1)
						If ColorPosition = -1 Then
							ColorPosition = Cache.ColorsMap.Size * SAME_COLOR_LENGTH_FOR_CACHE * 4
							Bit.ArrayCopy(mBuffer, offset  + 4 - SAME_COLOR_LENGTH_FOR_CACHE * 4, Cache.mBuffer, ColorPosition, SAME_COLOR_LENGTH_FOR_CACHE  * 4)
							Cache.ColorsMap.Put(key, ColorPosition)
						End If
						ColorKey = key
					End If
					#if B4i
					Bit.FastArraySetInt(Row, RowIndex, ColorPosition) : RowIndex = RowIndex + 1
					#else
					Row.Add(ColorPosition)
					#End If
					SameColorCount = 0
					CheckForSameColor = Cache.ColorsMap.Size < MAX_SAME_COLOR_SIZE
					EndOfLastSection = x
					CurrentState = CACHE_SOLID
					LastA = -1000
					Continue
				End If
			End If
			If NewState <> CurrentState Then
				'x is now the pixel with the new state!
				Dim LastSectionCount As Int = x - 1 - EndOfLastSection
				If LastSectionCount > 0 Then
					#if B4i
					Bit.FastArraySetInt(Row, RowIndex, CurrentState) : RowIndex = RowIndex + 1
					Bit.FastArraySetInt(Row, RowIndex, LastSectionCount) : RowIndex = RowIndex + 1
					#else
					Row.Add(CurrentState)
					Row.Add(LastSectionCount)
					#End If
					If CurrentState = CACHE_SOLID Then
						Index = Index + LastSectionCount
					End If
				End If
				EndOfLastSection = x - 1
				CurrentState = NewState
				If NewState = CACHE_SOLID Then SameColorCount = 1 Else SameColorCount = 0
			End If
		Next
		If EndOfLastSection < Right - 1 Then
			Dim LastSectionCount As Int = Right - 1 - EndOfLastSection
			#if B4i
			Bit.FastArraySetInt(Row, RowIndex, CurrentState) : RowIndex = RowIndex + 1
			Bit.FastArraySetInt(Row, RowIndex, LastSectionCount) : RowIndex = RowIndex + 1
			#else
			Row.Add(CurrentState)
			Row.Add(LastSectionCount)
			#End If
			If CurrentState = CACHE_SOLID  Then
				Index = Index + LastSectionCount
			End If
		End If
		#if B4i
		Dim brow(RowIndex * 4) As Byte
		Bit.ArrayCopy(Row, 0, brow, 0, RowIndex * 4)
		cbc.Rows.Add(brow)
		#else
		cbc.Rows.Add(Row)
		Dim c As Int
		For i = 1 To Row.Size - 1 Step 2
			Dim state As Int = Row.Get(i)
			If state > CACHE_SOLID Then
				c = c + state
			Else
				c = c + Row.Get(i + 1)
			End If
		Next
'		Log($"${y}: ${c}"$)
		#End If
	Next
	Dim data(Index * 4) As Byte
	cbc.mBuffer = data
	For y = 0 To cbc.Rows.Size - 1
		#if B4i
		Dim brow() As Byte = cbc.Rows.Get(y)
		Dim offsetInCBC As Int = Bit.FastArrayGetInt(brow, 0)
		Dim RowSize As Int = brow.Length / 4
		#else
		Dim Row As List = cbc.Rows.Get(y)
		Dim offsetInCBC As Int = Row.Get(0)
		Dim RowSize As Int = Row.Size
		#End If
		
		Dim RowOffet As Int = 0
		For i = 1 To RowSize - 1 Step 2
			#if B4i
			Dim state As Int = Bit.FastArrayGetInt(brow, i)
			Dim count As Int = Bit.FastArrayGetInt(brow, i + 1)
			#else
			Dim state As Int = Row.Get(i)
			Dim count As Int = Row.Get(i + 1)
			#end if	
			If state = CACHE_SOLID Then
				Bit.ArrayCopy(mBuffer, (Top + y) * mWidth * 4 + (Left + RowOffet) * 4, data, offsetInCBC * 4, count * 4)
				offsetInCBC = offsetInCBC + count
			Else If state > CACHE_SOLID Then
				count = state
			End If
			RowOffet = RowOffet + count
		Next
	Next
'	PrintBCRow(0)
'	PrintCBCRow(cbc, 0)
	Return cbc
End Sub



'Asynchronously draws all the draw tasks. Note that no other drawings should be made until the BitmapReady event is raised.
'The 'bmp' parameter will not be initialized in B4J.
'Target must be a class instance.
'Example: <code>bc1.DrawBitmapCreatorsAsync(Me, "BC", Tasks)
'Wait For BC_BitmapReady (bmp As B4XBitmap)
'</code>
Public Sub DrawBitmapCreatorsAsync(Target As Object, EventName As String, DrawTasks As List)
	#if Stats
	ClockForAsync = DateTime.Now
	#End If
	EventName = EventName.ToLowerCase
	#if Release
	If xui.IsB4i Then
		jme.RunMethod("DrawBitmapCreatorsAsync:::", Array(DrawTasks, EventName & "_bitmapready:", Target))
	Else
		jme.RunMethod("DrawBitmapCreatorsAsync", Array(DrawTasks, EventName, Target))
	End If
	#end if
End Sub


'Draws a scaled and / or rotated BitmapCreator. 
'Task.TargetX / TargetY define the target center. This is different than the behavior in other methods.
'Task.SkipBlending = True will treat all pixels with alpha > 0 as solid colors and other pixels as transparent.
Public Sub DrawBitmapCreatorTransformed (Task As DrawTask)
	#if Stats
	Dim Clock As Long = DateTime.Now
	#End If
	Dim Degrees As Int = Task.Degrees
	Dim SrcScaleX As Float = Task.SrcScaleX
	Dim SrcScaleY As Float = Task.SrcScaleY
	Dim SrcRect1 As B4XRect = Task.SrcRect
	Dim SrcRectWidth As Int = SrcRect1.Width
	Dim SrcRectHeight As Int = SrcRect1.Height
	Dim SrcRectLeft As Int = SrcRect1.Left
	Dim SrcRectRight As Int = SrcRect1.Right
	Dim SrcRectTop As Int = SrcRect1.Top
	Dim SrcRectBottom As Int = SrcRect1.Bottom
	
	Dim TargetX As Int = Task.TargetX
	Dim TargetY As Int = Task.TargetY
	Dim Source As BitmapCreator = Task.Source
	Degrees = Degrees Mod 360
	If Degrees < 0 Then Degrees = 360 + Degrees
	Dim width As Int = SrcRectWidth * SrcScaleX
	Dim height As Int = SrcRectHeight * SrcScaleY
	Dim SinL As Float = SinD(Degrees)
	Dim CosL As Float = CosD(Degrees)
	Dim SSrcX, SSrcY, STargetX, STargetY As Int
	Dim x0, y0, x1, y1, x2, y2, x3, y3 As Float
	x0 = 0
	y0 = 0
	x1 = width * CosL
	y1 = width * SinL
	x2 = width * CosL - height * SinL
	y2 = width * SinL + height * CosL
	x3 = -height * SinL
	y3 =  height * CosL
	Dim TopX, TopY, RightX, RightY, BottomX, BottomY, LeftX, LeftY As Int
	If Degrees < 90 Then
		TopX = x0
		TopY = y0
		RightX = x1
		RightY = y1
		BottomX = x2
		BottomY = y2
		LeftX = x3
		LeftY = y3
		TargetX = Round(TargetX - (x3 + x1) / 2)
		TargetY = Round(TargetY - (y2 - y0) / 2)
	Else If Degrees < 180 Then
		TopX = x3
		TopY = y3
		RightX = x0
		RightY = y0
		BottomX = x1
		BottomY = y1
		LeftX = x2
		LeftY = y2
		TargetX = Round(TargetX + (-x2 + x0) / 2)
		TargetY = Round(TargetY - (y1  + y3) / 2)
	Else If Degrees < 270 Then
		TopX = x2
		TopY = y2
		RightX = x3
		RightY = y3
		BottomX = x0
		BottomY = y0
		LeftX = x1
		LeftY = y1
		TargetX = Round(TargetX - (x1 + x3) / 2)
		TargetY = Round(TargetY + (y0 - y2) / 2)
	Else
		TopX = x1
		TopY = y1
		RightX = x2
		RightY = y2
		BottomX = x3
		BottomY = y3
		LeftX = x0
		LeftY = y0
		TargetX = Round(TargetX - (-LeftX + RightX) / 2)
		TargetY = Round(TargetY - (BottomY + TopY) / 2)
	End If
	If Degrees Mod 90 = 0 Then
		Dim FixedTopY As Int = Max(-TargetY, TopY)
		Dim FixedBottomY As Int = Min(mHeight - TargetY, BottomY)
		Dim FixedLeftX As Int = Max(-TargetX, LeftX)
		Dim FixedRightX As Int = Min(mWidth - TargetX, RightX)
		Dim dx As Float = 1 / SrcScaleX
		Dim dy As Float = 1 / SrcScaleY
		Dim SrcX, SrcY, StartX, StartY As Float
		If Degrees = 0 Or Degrees = 180 Then
			If Degrees = 0 Then
				StartX = SrcRectLeft
				StartY = SrcRectTop
			Else
				StartX = SrcRectRight - dx
				StartY = SrcRectBottom - dy
				dx = -dx
				dy = -dy
			End If
			Dim OffsetX As Float = (FixedLeftX - LeftX) * dx
			SrcY = StartY + (FixedTopY - TopY) * dy
			For y = FixedTopY To FixedBottomY - 1
				SSrcY = SrcY 
				SrcX = StartX + OffsetX
				STargetY = TargetY + y
				For x = FixedLeftX To FixedRightX - 1
					SSrcX = SrcX 
					STargetX = TargetX + x
					#if B4i
					If Task.SkipBlending = False Then
						BlendPixel(Source, SSrcX, SSrcY, STargetX, STargetY)
					Else
						Dim SourceCP As Int = SSrcX * 4 + SSrcY * Source.mWidth * 4
						If Bit.FastArrayGetByte(Source.mBuffer, SSrcX * 4 + SSrcY * Source.mWidth * 4 + ai) > 0 Then
							Dim TargetCP As Int = STargetX * 4 + STargetY * mWidth * 4
							Bit.FastArraySetByte(mBuffer, TargetCP, Bit.FastArrayGetByte(Source.mBuffer, SourceCP))
							Bit.FastArraySetByte(mBuffer, TargetCP + 1, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 1))
							Bit.FastArraySetByte(mBuffer, TargetCP + 2, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 2))
							Bit.FastArraySetByte(mBuffer, TargetCP + 3, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 3))
						End If
					End If
					#else
					CopyPixelIgnoreSemiTransparent(Source, SSrcX, SSrcY, STargetX, STargetY , Task.SkipBlending)
					#end if
					SrcX = SrcX + dx
				Next
				SrcY = SrcY + dy
			Next
		Else If Degrees = 90 Or Degrees = 270 Then
			If Degrees = 90 Then
				StartY = SrcRectBottom - dy
				dy = -dy
				StartX = SrcRectLeft
			Else
				StartY = SrcRectTop
				StartX = SrcRectRight - dx
				dx = -dx
			End If
			SrcX = StartX + (FixedTopY - TopY) * dx
			Dim OffsetY As Float = dy * (FixedLeftX - LeftX)
			For y = FixedTopY To FixedBottomY - 1
				SrcY = StartY + OffsetY
				STargetY = y + TargetY
				SSrcX = SrcX
				For x = FixedLeftX To FixedRightX - 1
					SSrcY = SrcY
					STargetX = TargetX + x
					#if B4i
					If Task.SkipBlending = False Then
						BlendPixel(Source, SSrcX, SSrcY, STargetX, STargetY)
					Else
						Dim SourceCP As Int = SSrcX * 4 + SSrcY * Source.mWidth * 4
						If Bit.FastArrayGetByte(Source.mBuffer, SSrcX * 4 + SSrcY * Source.mWidth * 4 + ai) > 0 Then
							Dim TargetCP As Int = STargetX * 4 + STargetY * mWidth * 4
							Bit.FastArraySetByte(mBuffer, TargetCP, Bit.FastArrayGetByte(Source.mBuffer, SourceCP))
							Bit.FastArraySetByte(mBuffer, TargetCP + 1, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 1))
							Bit.FastArraySetByte(mBuffer, TargetCP + 2, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 2))
							Bit.FastArraySetByte(mBuffer, TargetCP + 3, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 3))
						End If
					End If
					#else
					CopyPixelIgnoreSemiTransparent(Source, SSrcX, SSrcY, STargetX, STargetY , Task.SkipBlending)
					#end if
					SrcY = SrcY + dy
				Next
				SrcX = SrcX + dx
			Next
		End If
		Return
	End If
	Dim c1 As Float = TanD(Degrees)
	Dim c2 As Float = CosL + c1 * SinL
	Dim ct2x As Float = 1 / c2 / SrcScaleX
	Dim ct2y As Float = c1 / c2 / SrcScaleY
	Dim SrcLeft As Int = SrcRectLeft
	Dim SrcTop As Int = SrcRectTop
	For y = Max(-TargetY, TopY) To Min(mHeight - 1 - TargetY, BottomY - 1)
		Dim XStart, XEnd As Int
		If y <= LeftY Then
			XStart = TopX + (y - TopY) * (LeftX - TopX) / (LeftY - TopY)
		Else
			XStart = LeftX + (y - LeftY) * (BottomX - LeftX) / (BottomY - LeftY)
		End If
		If y <= RightY Then
			XEnd = TopX + (y - TopY) * (RightX - TopX) / (RightY - TopY)
		Else
			XEnd = RightX + (y - RightY) * (BottomX - RightX) / (BottomY - RightY)
		End If
		XStart = Max(-TargetX, XStart)
		XEnd = Min(mWidth - TargetX, XEnd)
		Dim sx As Float = Min(Max((XStart + y * c1) / c2, 0), width - 1) / SrcScaleX
		Dim sy As Float = Min(Max((y - XStart * c1) / c2, 0), height - 1) / SrcScaleY
	
		Dim EndSX As Float = sx + ct2x * (XEnd - 1 - XStart)
		Do While (EndSX < 0 Or EndSX >= SrcRectRight - 0.1) And XEnd - 1 >= XStart
			XEnd = XEnd - 1
			EndSX = sx + ct2x * (XEnd - 1 - XStart)
		Loop
		Dim EndSY As Float = sy - ct2y * (XEnd - 1 - XStart)
		Do While (EndSY < 0 Or EndSY >= SrcRectBottom - 0.1) And XEnd - 1 >= XStart
			XEnd = XEnd - 1
			EndSY = sy - ct2y * (XEnd - 1 - XStart)
		Loop
		
		For x = XStart To XEnd - 1
			#if B4i
			SSrcX = SrcLeft + sx
			SSrcY = SrcTop + sy
			STargetX = TargetX + x
			STargetY = TargetY + y
			If Task.SkipBlending = False Then
				BlendPixel(Source, SSrcX, SSrcY, STargetX, STargetY)
			Else
				Dim SourceCP As Int = SSrcX * 4 + SSrcY * Source.mWidth * 4
				Dim a As Byte = Bit.FastArrayGetByte(Source.mBuffer, SSrcX * 4 + SSrcY * Source.mWidth * 4 + ai)
				If a > 0 Then
					Dim TargetCP As Int = STargetX * 4 + STargetY * mWidth * 4
					Bit.FastArraySetByte(mBuffer, TargetCP, Bit.FastArrayGetByte(Source.mBuffer, SourceCP))
					Bit.FastArraySetByte(mBuffer, TargetCP + 1, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 1))
					Bit.FastArraySetByte(mBuffer, TargetCP + 2, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 2))
					Bit.FastArraySetByte(mBuffer, TargetCP + 3, a)
				End If
			End If
			#else
			CopyPixelIgnoreSemiTransparent(Source, SrcLeft + sx, SrcTop + sy, TargetX + x, TargetY + y, Task.SkipBlending)
			#End If
			sx = sx + ct2x
			sy = sy - ct2y
		Next
	Next
	#if Stats
	Log($"DrawBitmapCreatorTransformed: ${DateTime.Now - Clock} ms"$)
	#End If
End Sub

Public Sub CopyPixelIgnoreSemiTransparent (Source As BitmapCreator, SrcX As Int, SrcY As Int, _
		 TargetX As Int, TargetY As Int, SkipBlending As Boolean) 'ignore
	If SkipBlending = False Then
		BlendPixel(Source, SrcX, SrcY, TargetX, TargetY)
		Return
	End If
	Dim SourceCP As Int = SrcX * 4 + SrcY * Source.mWidth * 4
	Dim a As Int = Source.mBuffer(SourceCP + ai)
	If a = 0 Then Return
	Dim TargetCP As Int = TargetX * 4 + TargetY * mWidth * 4
	mBuffer(TargetCP) = Source.mBuffer(SourceCP)
	mBuffer(TargetCP + 1) = Source.mBuffer(SourceCP + 1)
	mBuffer(TargetCP + 2) = Source.mBuffer(SourceCP + 2)
	mBuffer(TargetCP + 3) = Source.mBuffer(SourceCP + 3)
End Sub

'Copies a single pixel from Source to this BC. 
Public Sub CopyPixel (Source As BitmapCreator, SrcX As Int, SrcY As Int, TargetX As Int, TargetY As Int)
	Dim SourceCP As Int = SrcX * 4 + SrcY * Source.mWidth * 4
	Dim TargetCP As Int = TargetX * 4 + TargetY * mWidth * 4
#if B4i
	Bit.FastArraySetByte(mBuffer, TargetCP, Bit.FastArrayGetByte(Source.mBuffer, SourceCP))
	Bit.FastArraySetByte(mBuffer, TargetCP + 1, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 1))
	Bit.FastArraySetByte(mBuffer, TargetCP + 2, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 2))
	Bit.FastArraySetByte(mBuffer, TargetCP + 3, Bit.FastArrayGetByte(Source.mBuffer, SourceCP + 3))
#else
	mBuffer(TargetCP) = Source.mBuffer(SourceCP)
	mBuffer(TargetCP + 1) = Source.mBuffer(SourceCP + 1)
	mBuffer(TargetCP + 2) = Source.mBuffer(SourceCP + 2)
	mBuffer(TargetCP + 3) = Source.mBuffer(SourceCP + 3)
#End If
End Sub

'Copies a single pixel from Source to this BC. If the pixel is non-opaque then it will blend with the current pixel.
Public Sub BlendPixel (Source As BitmapCreator, SrcX As Int, SrcY As Int, TargetX As Int, TargetY As Int)
	Dim SrcPM As PremultipliedColor = Source.GetPremultipliedColor(SrcX, SrcY, tempPM2)
	If SrcPM.a <> UnsignedFF Then
		If SrcPM.a = 0 Then Return
		SrcPM.a = Bit.And(0xff, SrcPM.a)
		GetPremultipliedColor(TargetX, TargetY, tempPM)
		Dim SrcAF As Float = 1 - (SrcPM.a / 255)
		SrcPM.r =  Bit.And(0xff, SrcPM.r) + SrcAF *  Bit.And(0xff, tempPM.r)
		SrcPM.g =  Bit.And(0xff, SrcPM.g) + SrcAF *  Bit.And(0xff, tempPM.g)
		SrcPM.b =  Bit.And(0xff, SrcPM.b) + SrcAF *  Bit.And(0xff, tempPM.b)
		SrcPM.a =  Bit.And(0xff, SrcPM.a) + SrcAF *  Bit.And(0xff, tempPM.a)
	End If
	SetPremultipliedColor(TargetX, TargetY, SrcPM)
End Sub

Public Sub BlendPixel2 (SrcPM As PremultipliedColor, TargetX As Int, TargetY As Int)
	If SrcPM.a <> UnsignedFF Then
		If SrcPM.a = 0 Then Return
		tempPM2.a = Bit.And(0xff, SrcPM.a)
		GetPremultipliedColor(TargetX, TargetY, tempPM)
		Dim SrcAF As Float = 1 - (tempPM2.a / 255)
		tempPM2.r =  Bit.And(0xff, SrcPM.r) + SrcAF *  Bit.And(0xff, tempPM.r)
		tempPM2.g =  Bit.And(0xff, SrcPM.g) + SrcAF *  Bit.And(0xff, tempPM.g)
		tempPM2.b =  Bit.And(0xff, SrcPM.b) + SrcAF *  Bit.And(0xff, tempPM.b)
		tempPM2.a =  Bit.And(0xff, tempPM2.a) + SrcAF *  Bit.And(0xff, tempPM.a)
		SetPremultipliedColor(TargetX, TargetY, tempPM2)
	Else
		SetPremultipliedColor(TargetX, TargetY, SrcPM)
	End If
End Sub



#Region *************************  Gradients *****************************
'Fills the rectangle with a gradient. Skips blending.
'GradColors - An array of two or more colors that define the gradient.
'Rect - The region that will be filled.
'Orientation - One of the following: TL_BR, TOP_BOTTOM, TR_BL, LEFT_RIGHT, RIGHT_LEFT, BL_TR, BOTTOM_TOP, BR_TL and RECTANGLE.
Public Sub FillGradient (GradColors() As Int, Rect As B4XRect, Orientation As String)
	If Rect.Width <= 1 Or Rect.Height <= 1 Or Rect.Left >= mWidth Or Rect.Top >= mHeight Then Return
	If GradColors.Length = 1 Then
		FillRect(GradColors(0), Rect)
		Return
	End If
	Dim SinL As Float
	Dim StartY As Int = Max(Rect.Top, 0)
	Dim EndY As Int = Min(Rect.Bottom - 1, mHeight - 1)
	Dim ox, deltaox As Float
	Dim AxisLength As Int
	Dim TopBottom As Boolean
	Dim OppositeColors As Boolean
	Dim TR_BL As Boolean
	Dim Rectangle As Boolean
	Dim NumberOfParts As Int = GradColors.Length - 1
	Dim DFix(NumberOfParts + 1) As Float
	Dim DFixDivSinL(NumberOfParts + 1) As Float
	Select Orientation
		Case "TL_BR", "BR_TL", "TR_BL", "BL_TR"
			Dim alpha As Float = ATanD(Rect.Width / Rect.Height)
			SinL = SinD(alpha)
			AxisLength = Sqrt(Power(Rect.Width, 2) + Power(Rect.Height, 2))
			Dim TanL As Float = TanD(alpha)
			deltaox = 1 / TanL
			ox = (StartY - Rect.Top) / TanL
			OppositeColors = Orientation = "BR_TL" Or Orientation = "BL_TR"
			TR_BL = Orientation = "TR_BL" Or Orientation = "BL_TR"
		Case "LEFT_RIGHT", "RIGHT_LEFT"
			AxisLength = Rect.Width
			deltaox = 0
			SinL = 1
			OppositeColors = Orientation = "RIGHT_LEFT"
		Case "TOP_BOTTOM", "BOTTOM_TOP"
			AxisLength = Rect.Height
			SinL = 0
			ox = 0
			TopBottom = True
			OppositeColors = Orientation = "BOTTOM_TOP"
		Case "RECTANGLE"
			AxisLength = Max(Rect.Width, Rect.Height) / 2
			Rectangle = True
		Case Else
			Log("Invalid orientation: " & Orientation)
	End Select
	
	Dim RGBColor(GradColors.Length) As ARGBColor
	For i = 0 To GradColors.Length - 1
		Dim a As Int = i
		If OppositeColors Then a = GradColors.Length - 1 - i
		ColorToARGB(GradColors(a), RGBColor(i))
	Next
	
	For i = 0 To NumberOfParts
		DFix(i) = i / NumberOfParts * AxisLength
		DFixDivSinL(i) = DFix(i) / SinL
	Next
	Dim EndMax As Int = Min(mWidth - 1, Rect.Right - 1)
	Dim StartMin As Int = Max(Rect.Left, 0)
	Dim ClrFrom, ClrTo As ARGBColor
	Dim argb As ARGBColor
	Dim tStartX, tEndX, tStep = 1 As Int
	If Rectangle Then
		Dim cx As Int = Rect.CenterX
		Dim cy As Int = Rect.CenterY
		Dim width As Int = Rect.Width
		Dim height As Int = Rect.Height
		If (width Mod 2) = 0 Or (height Mod 2) = 0 Then AxisLength = AxisLength - 1
		Dim XFix = Min(1, width / height), YFix = Min(1, height / width) As Float
		For part = 0 To NumberOfParts - 1
			ClrFrom = RGBColor(part)
			ClrTo = RGBColor(part + 1)
			For r = part / NumberOfParts * AxisLength To (part + 1) / NumberOfParts * AxisLength
				Dim dd As Float = (r - DFix(part)) / (AxisLength / NumberOfParts)
				For x = -r To r
					argb.a = ClrFrom.a + dd * (ClrTo.a - ClrFrom.a)
					argb.r = ClrFrom.r + dd * (ClrTo.r - ClrFrom.r)
					argb.g = ClrFrom.g + dd * (ClrTo.g - ClrFrom.g)
					argb.b = ClrFrom.b + dd * (ClrTo.b - ClrFrom.b)
					ARGBToPremultipliedColor(argb, tempPM)
					SetPremultipliedColor(cx + x * XFix, cy - r * YFix, tempPM)
					SetPremultipliedColor(cx + x * XFix, cy + r * YFix, tempPM)
					SetPremultipliedColor(cx - r * XFix, cy + x * YFix, tempPM)
					SetPremultipliedColor(cx + r * XFix, cy + x * YFix, tempPM)
				Next
			Next
		Next
		Dim RectLeft = Rect.Left, RectRight = Rect.Right, RectTop = Rect.Top, RectBottom = Rect.Bottom As Int
		For x = RectLeft To RectRight - 1
			SetPremultipliedColor(x, RectTop, tempPM)
			SetPremultipliedColor(x, RectBottom - 1, tempPM)
		Next
		For y = RectTop To RectBottom - 1
			SetPremultipliedColor(RectLeft, y, tempPM)
			SetPremultipliedColor(RectRight - 1, y, tempPM)
		Next
	Else
		For y = StartY To EndY
			Dim EndX As Int = Rect.Left - ox - 1
			For part = 0 To NumberOfParts - 1
				ClrFrom = RGBColor(part)
				ClrTo = RGBColor(part + 1)
				If TopBottom Then
					Dim d As Float = y - Rect.Top
					Dim dd As Float = (d - DFix(part)) / (AxisLength / NumberOfParts)
					If dd < 0 Or dd > 1 Then
						Continue
					End If
					Dim tStartX As Int = StartMin
					Dim tEndX As Int = EndMax
				Else
					Dim StartX As Int = Max(StartMin, EndX + 1)
					Dim EndX As Int = Min(Rect.Left + DFixDivSinL(part + 1) - ox, EndMax)
					Dim d As Float = SinL * (StartX - Rect.Left + ox)
					Dim ddDelta As Float = SinL / (AxisLength / NumberOfParts)
					Dim dd As Float = (d - DFix(part)) / (AxisLength / NumberOfParts)
					If TR_BL Then
						tStartX = Rect.Right - 1 - (StartX - Rect.Left)
						tEndX = Rect.Right - 1 - (EndX - Rect.Left)
						tStep = -1
					Else
						tStartX = StartX
						tEndX = EndX
					End If
				End If
				For	x = tStartX To tEndX Step tStep
					argb.a = ClrFrom.a + dd * (ClrTo.a - ClrFrom.a)
					argb.r = ClrFrom.r + dd * (ClrTo.r - ClrFrom.r)
					argb.g = ClrFrom.g + dd * (ClrTo.g - ClrFrom.g)
					argb.b = ClrFrom.b + dd * (ClrTo.b - ClrFrom.b)
					SetARGB(x, y, argb)
					dd = dd + ddDelta
				Next
			Next
			ox = ox + deltaox
		Next
	End If
	
End Sub

'Fills the rectangle with a radial gradient. Skips blending.
Public Sub FillRadialGradient (GradColors() As Int, Rect As B4XRect)
	Dim RGBColor(GradColors.Length) As ARGBColor
	For i = 0 To GradColors.Length - 1
		ColorToARGB(GradColors(i), RGBColor(i))
	Next
	Dim MaxDistance As Int = Ceil(Sqrt(Power(Rect.Width / 2, 2) + Power(Rect.Height / 2, 2)))
	Dim DistanceToColor(MaxDistance) As ARGBColor
	Dim CurrentColorIndex As Int
	Dim LengthOfEachColor As Int = Ceil(MaxDistance / (GradColors.Length - 1))
	Dim c As Int
	For i = 0 To MaxDistance - 1
		Dim l As Float = CurrentColorIndex / LengthOfEachColor
		DistanceToColor(i).a = RGBColor(c).a + l * (RGBColor(c + 1).a - RGBColor(c).a)
		DistanceToColor(i).r = RGBColor(c).r + l * (RGBColor(c + 1).r - RGBColor(c).r)
		DistanceToColor(i).g = RGBColor(c).g + l * (RGBColor(c + 1).g - RGBColor(c).g)
		DistanceToColor(i).b = RGBColor(c).b + l * (RGBColor(c + 1).b - RGBColor(c).b)
		CurrentColorIndex = CurrentColorIndex + 1
		If CurrentColorIndex = LengthOfEachColor Then
			CurrentColorIndex = 0
			c = c + 1
		End If
	Next
	Dim cx As Int = Rect.CenterX
	Dim cy As Int = Rect.CenterY
	For x = Max(0, Rect.Left) To Min(mWidth - 1, Rect.Right - 1)
		Dim dx As Int = Power(x - cx, 2)
		For y = Max(0, Rect.Top) To Min(mHeight - 1, Rect.Bottom - 1)
			Dim distance As Int = Sqrt(dx + Power(y - cy, 2))
			SetARGB(x, y, DistanceToColor(distance))
		Next
	Next
End Sub
#End Region

#Region *****************  Native code ***********
#if Release
#if B4A
#if Java
public void DrawBitmapCreatorsAsync( final java.util.List<_drawtask> tasks, final String eventName, final B4AClass targetModule) {
	ba.submitRunnable(new Runnable() {
	public void run() {
		try {
			long clock = System.currentTimeMillis();
			for (_drawtask dt : tasks) {
				bitmapcreator target = dt.TargetBC == null ? bitmapcreator.this : dt.TargetBC;
				if (dt.Transform)
					target._drawbitmapcreatortransformed(dt);
				else if (dt.IsCompressedSource)
					target._drawcompressedbitmap((_compressedbc)dt.Source, dt.SrcRect, dt.TargetX, dt.TargetY);
				else if (dt.IsCanvasTask)
					target._drawcanvasasync(dt);
				else
					target._drawbitmapcreator((bitmapcreator)dt.Source, dt.SrcRect, dt.TargetX, dt.TargetY, dt.SkipBlending);
			}
			//_clockforasync = System.currentTimeMillis();
			BA.handler.postAtFrontOfQueue(new Runnable() {
				public void run() {
					try {
						targetModule.getBA().raiseEvent2(null, false, eventName + "_bitmapready", false, _getbitmap());
						} catch (Exception e2) {
						e2.printStackTrace();
					}
				}
			});
			//BA.Log("" + (System.currentTimeMillis() - clock));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	}, null, 0);
}
#end if
#else If B4J
#if Java
public void DrawBitmapCreatorsAsync( final java.util.List<_drawtask> tasks, final String eventName, final B4AClass targetModule) {
	ba.submitRunnable(new Runnable() {
	public void run() {
		try {
			long clock = System.currentTimeMillis();
			for (_drawtask dt : tasks) {
				bitmapcreator target = dt.TargetBC == null ? bitmapcreator.this : dt.TargetBC;
				if (dt.Transform)
					target._drawbitmapcreatortransformed(dt);
				else if (dt.IsCompressedSource)
					target._drawcompressedbitmap((_compressedbc)dt.Source, dt.SrcRect, dt.TargetX, dt.TargetY);
				else if (dt.IsCanvasTask)
					target._drawcanvasasync(dt);
				else
					target._drawbitmapcreator((bitmapcreator)dt.Source, dt.SrcRect, dt.TargetX, dt.TargetY, dt.SkipBlending);
			}
			targetModule.getBA().raiseEventFromDifferentThread(null, null, 0, eventName + "_bitmapready", false, new Object[] {null});
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	}, null, 0);
}
#end if
#End If
#end if
#if RELEASE
#if OBJC
- (void) DrawBitmapCreatorsAsync:(NSArray*)tasks :(NSString*)eventName :(B4IClass*) targetModule{
	dispatch_async (dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
		for (_drawtask* dt in tasks) {
			b4i_bitmapcreator* target = dt->_TargetBC == nil ? self : dt->_TargetBC;
			if (dt->_Transform)
				[target _drawbitmapcreatortransformed:dt];
			else if (dt->_IsCompressedSource)
				[target _drawcompressedbitmap:dt->_Source :dt->_SrcRect :dt->_TargetX :dt->_TargetY];
			else if (dt->_IsCanvasTask)
				[target _drawcanvasasync:dt];
			else
				[target _drawbitmapcreator:dt->_Source :dt->_SrcRect :dt->_TargetX :dt->_TargetY :dt->_SkipBlending];
		}
		[targetModule.bi raiseEventFromDifferentThread:nil event:eventName params:@[[self _getbitmap]]];
	});
}
#end if
#end if
#if OBJC

- (void)UIImageToBuffer:(UIImage*) bmp :(NSData*)data :(int)width :(int)height :(BOOL)shouldClear{
	if (shouldClear)
		memset ([(NSMutableData*)data mutableBytes],0, data.length);
	CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
	CGContextRef context = CGBitmapContextCreate([(NSMutableData*)data mutableBytes], 
			width, 
			height, 
			8, 
			4 * width, 
			colorSpace, 
			kCGImageAlphaPremultipliedLast); 
	if(!context) {
		NSLog(@"Failed To create bitmap context");
	}		
	CGColorSpaceRelease(colorSpace);
	CGImageRef imageRef = bmp.CGImage;
	CGRect Rect = CGRectMake(0, 0, width, height);
	CGContextDrawImage(context, Rect, imageRef);
	CGContextRelease(context);
}
- (UIImage*) bufferToUIImage:(NSData*)data :(int)width :(int)height {
	CGDataProviderRef provider = CGDataProviderCreateWithCFData( (CFDataRef) data );
	CGColorSpaceRef colorSpaceRef = CGColorSpaceCreateDeviceRGB();
	CGBitmapInfo bitmapInfo = kCGBitmapByteOrderDefault | kCGImageAlphaPremultipliedLast;
	CGColorRenderingIntent renderingIntent = kCGRenderingIntentDefault;
	
	CGImageRef iref = CGImageCreate(width, 
				height, 
				8, 
				32, 
				4 * width, 
				colorSpaceRef, 
				bitmapInfo, 
				provider,	
				NULL,	
				NO,
		renderingIntent);
	UIImage* image = [UIImage imageWithCGImage:iref scale:1 orientation:UIImageOrientationUp];
	CGColorSpaceRelease(colorSpaceRef);
	CGImageRelease(iref);
	CGDataProviderRelease(provider);
	return image;
}
#End If

#End Region